subprogram efs;

%listing off
%insert pmed_globals.pas
%listing on

{---start---}

{  *****************************************
   * EDITOR FILE SYSTEM LOW LEVEL ROUTINES *
   ***************************************** }


{ procedures (for calling from DBG ) to print diagnostics }

procedure writeptr(ptr: ptrfileblock);                                          { writeptr }

type
   string = packed array[1..2] of char;

   procedure ioa$(text: string;
                length: shortint;
                  var1: ptrfileblock); extern;

begin
   ioa$('%p', short(2), ptr)
end;

procedure printblock;                                                           { printblock }

var
   indexval: integer;

begin
   writeln('indexsub = ',indexsub:1,'  blocks = ', blocks:1);
   write('Give index of block to print: ');
   readln(indexval);
   if (indexval < 1) or
      (indexval > indexmax)
   then writeln('Must be >= 1 and <= ',indexmax:1)
   else
   with index[indexval], blockad^ do
   begin
      write('index entry = (', blocklines:1,' , ');
      writeptr(blockad); writeln(')');
      writeln('blockad^.splitstart = ', splitstart:1,
                        ' splitend = ', splitend:1);
      write('blockaddress = '); writeptr(blockaddress); writeln;
      writeln('linesabove = ', linesabove:1,
        ' lastlineinblock = ', lastlineinblock:1)
   end
end;

{ close a primos file }

procedure closefile( var pfile: primosfile);                                    { closefile }

var
   tipe, code: shortint;

   procedure srch$$( key: integer;
                  filnam: integer;
                  namlen: integer;
               var funit: shortint;
                var tipe: shortint;
                var code: shortint); extern;

begin
   with pfile do
   begin
      srch$$( k$clos, 0, 0, unit, tipe, code);
      if long(code) <> 0 then
         errpr$(k$irtn, code, treename, short(treelength), 'SRCH$$', short(6) );
      open := false
   end
end;

{ Open a primos file with the key given - adds k$getu to key }

procedure openfile( key: integer;                                               { openfile }
              var pfile: primosfile);

var
   chrpos: tree0range;
   tipe, rnw, code: shortint;
   done, append: boolean;

   procedure tsrc$$( key: integer;
                treename: treestring;
               var funit: shortint;
              var chrpos: tree0range;
                var tipe: shortint;
                var code: shortint); extern;

begin
   with pfile do
   begin
      done := false;                    { strip trailing spaces }
      repeat
         if treelength = 0
         then done := true
         else if treename[treelength] = ' '
         then treelength := treelength - 1
         else done := true
      until
         done;
      chrpos := treelength;
      if (treelength > 0) and           { test for (append) on treename }
         (treename[treelength] = ')') then
      begin
         append := true;                { assume it is (append) }
         done := false;
         repeat                         { trime down to '(' }
            if chrpos = 0
            then done := true
            else if treename[chrpos] <> '('
            then chrpos := chrpos - 1
            else
            begin
               done := true;
               chrpos := chrpos - 1
            end
         until
            done
      end
      else append := false;
      open := false;
      tipe := short(0);
      tsrc$$( key+k$getu, treename, unit, chrpos, tipe, code);
      if long(code) <> 0 then
         errpr$(k$irtn, code, treename, short(treelength), 'TSRC$$', short(6) )
      else if long(tipe) > 1 then
      begin
         writeln('File is a directory');
         closefile(pfile)
      end
      else
      begin
         open := true;
         if key=k$writ then
         begin
            if append then
            begin                       { position to end of file }
               prwf$$(k$posn, unit, 0, short(0), maxint, rnw, code);
               if long(code) = e$eof
               then code := short(0)
            end
            else                        { truncate output file }
               prwf$$(k$trnc, unit, 0, short(0), 0, rnw, code);
            if long(code) <> 0 then
            begin
               errpr$(k$irtn, code, treename, short(treelength),
                      'PRWF$$', short(6) );
               closefile(pfile)
            end
         end;
         prepos := 0
      end
   end
end;

{ Look in the given block for the next word containing a newline, updating
  wordindex to point to it. }

procedure findnextnewline( var area: datawordstype;                             { findnextnewline }
                      var wordindex: datawords0p1range;
                        startofarea: datawordsrange;
                          backwards: boolean);

var
   wordsplit: wordsplittype;
   found: boolean;
   increment: -1..1;
   windex: datawordsrange;

begin
   found := false;
   if backwards
   then increment := -1
   else increment := 1;
   windex := wordindex;                 { use local range for speed }
   with wordsplit do
   repeat
      word := area[windex];
      if chars[2] = newline             { need to check that newline is not }
      then found := chars[1] <> dc1;    { just a count of 138 following dc1 }
      if chars[1] = newline
      then  if windex = startofarea     { do not look before start of area }
            then found := true          { first ch in block }
            else
            begin
               word := area[windex-1];
               found := chars[2] <> dc1
            end;
      if not found
      then windex := windex + increment
   until found;
   wordindex := windex
end;

{ Count the lines in the part of a file block indicated by word
  subscripts 'start' and 'stop'. Set 'lastnl' to word subscript of last
  newline found. }

function countlines( var area: datawordstype;                                   { countlines }
                        start: datawordsrange;
                         stop: datawords0range;
                   var lastnl: datawords0range): integer;

var
   wordsplit: wordsplittype;
   count: integer;
   index: datawordsrange;
   found: boolean;

begin
   count := 0;
   lastnl := start - 1;                 { default if no newlines found }
   with wordsplit do
   for index := start to stop do
   begin
      word := area[index];
      found := false;
      if chars[2] = newline             { need to check that newline is not }
      then found := chars[1] <> dc1;    { count char following a dc1 }
      if chars[1] = newline
      then  if index = start
            then found := true          { first ch in range }
            else
            begin
               word := area[index-1];
               found := chars[2] <> dc1
            end;
      if found then
      begin
         count := count + 1;
         lastnl := index
      end
   end;
   countlines := count
end;

{ read some text from a primos file into part of the current block }

procedure readablock( var pfile: primosfile;                                    { readablock }
               var lastlineread: integer);

var
   rnw, code: shortint;
   newsplitstart, correctedsplitstart, wordsfull, toread, addedlines: integer;
   lastnl, ignore: datawords0range;

   procedure addnewlineatend;           { add newline to end of text }
   begin
      if testing then writeln('readablock: addnewlineatend');
      blockaddress^.datachars[ newsplitstart*2 - 1 ] := newline;
      newsplitstart := newsplitstart + 1
   end;

begin
   with index[indexsub], blockaddress^ do
   begin
      wordsfull := blockmaxwords - (splitend - splitstart);
      if wordsfull = 0
      then  toread := blocktidewords    { fill empty blocks to tidemark }
      else  toread :=                   { fill up part full block }
               blockmaxwords - wordsfull - 1;  { allow space for newline
                                                     which might be needed }
      if testing then writeln('readablock: toread = ',toread:1);
      if toread > 0 then
      with pfile do
      begin
         if testing then writeln('readablock: prepos = ',prepos:1,
                                 ' before calling prwf$$');
         prwf$$( k$read, unit, addressof( datawords[ splitstart ] ),
                 short(toread), prepos, rnw, code);
         newsplitstart := splitstart + long(rnw);
         if long(code) = e$eof then
         begin                          { end of file reached }
            closefile(pfile);
            code := short(0);           { do not treat eof as error }
            open := false;
            if testing then writeln('readablock: file closed');
            if long(rnw) > 0            { some words actually read }
            then
               if (datachars[newsplitstart*2 - 3] <> newline ) and
                  (datachars[newsplitstart*2 - 2] <> newline )
               then addnewlineatend     { no newline at end of file }
         end;
         if long(code) <> 0 then
         begin
            errpr$(k$irtn, code, treename, short(treelength),
                   'PRWF$$', short(6) );
            newsplitstart := splitstart;  { no lines read }
            mainstate := commanderror
         end;
         addedlines :=
            countlines( datawords, splitstart, newsplitstart-1, lastnl);
         if (addedlines = 0) and (wordsfull = 0) and (long(rnw) > 0) then
         begin                          { no newlines in whole block }
            lastnl := newsplitstart;
            addnewlineatend;
            addedlines := 1
         end;
         { compute the relative line number of the last line read in }
         lastlineread := addedlines +
            countlines(datawords, 1, splitstart - 1, ignore);
         correctedsplitstart := lastnl + 1;
         { the part of the block after the last newline will be read again
           by the next call to prwf$$ - prepos is the number of words }
         prepos := -( long(rnw) - (correctedsplitstart - splitstart) );
         blocklines := blocklines + addedlines;
         splitstart := correctedsplitstart;
         if testing then
         begin
            writeln('readablock: prepos = ',prepos:1,
                           ' splitstart = ',splitstart:1,
                             ' splitend = ',splitend:1);
            writeln(       ' addedlines = ',addedlines:1,
                         ' lastlineread = ',lastlineread:1)
         end
      end
      else lastlineread := 0
   end
end;

{ Set up a new empty block at indexsub position }

procedure setupemptyblock;                                                      { setupemptyblock }

begin
   with index[indexsub] do
   begin
      blocklines := 0;                  { no lines in block yet }
      new(blockaddress);                { create the block }
      blockad := blockaddress;
      with blockaddress^ do
      begin
         splitstart := 1;               { split goes from word 1 }
         splitend := blockmaxwords + 1  { to top of block }
      end
   end
end;

{ Initial read of a block of file - uses 'indexsub' }

procedure readnewblock( var pfile: primosfile);                                 { readnewblock }

var
   lastlineread: integer;

begin
   setupemptyblock;
   readablock(pfile, lastlineread)      { fill it up to tidemark }
end;

{ Write the text of the current block to file
  Does not assume 'blockaddress' set. }

procedure writeablock( pfile: primosfile;                                       { writeablock }
                      var ok: boolean);

var
   rnw, code: shortint;

begin
   with pfile, index[indexsub].blockad^ do
   begin
      prwf$$( k$writ, unit, addressof( datawords[1] ),
              short(splitstart - 1), 0, rnw, code);
      ok := long(code) = 0;
      if not ok then
         errpr$(k$irtn, code, treename, short(treelength), 'PRWF$$', short(6) )
   end
end;

{ Compress spaces in current line and return length in words }

procedure compressline( var length: linewordsrange);                            { compressline }

var
   spaces, count: integer;
   lindex: linecharsrange;
   toindex: linechars0range;
   ch: char;

   procedure store(ch: char);
   begin
      toindex := toindex + 1;
      compressedline.linechars[toindex] := ch
   end;

begin
   toindex := 0;
   spaces := 0;
   for lindex := 1 to linelength do
   begin
      ch := line[lindex];
      if ch = ' ' then spaces := spaces + 1
      else
      begin
         if spaces <= 2 then            { not worth it for up to 2 spaces }
         begin
            for count := 1 to spaces do store(' ');
            spaces := 0
         end
         else
         while spaces > 0 do            { output (dc1,count) for chunks of }
         begin                          { up to 127 spaces }
            store(dc1);
            if spaces > 127 then count := 127
                            else count := spaces;
%checks off                             { Sheffield pascal does not like }
            store(chr(count));          { characters with ord < 128 }
%checks on
            spaces := spaces - count
         end;
         store(ch)
      end
   end;
   store(newline);                      { add newline at end }
   if toindex mod 2 <> 0                { pad with zero if necessary }
%checks off
   then store(chr(0));                  { must be zero or FTN complains }
%checks on
   length := toindex div 2              { length in words }
end;

{ Close the split in the current block }

procedure closesplit;                                                           { closesplit }

var
   dindex: datacharsrange;

begin
   with blockaddress^ do
   begin
      for dindex := splitend to blockmaxwords do
         datawords[splitstart + dindex - splitend] := datawords[dindex];
      splitstart := splitstart + blockmaxwords + 1 - splitend;
      splitend := blockmaxwords + 1
   end
end;

{ Move the split in the current block to after the current line }

procedure movesplit;                                                            { movesplit }

var
   bindex: datawordsrange;
   moved: datawords0range;

begin
   with blockaddress^ do
   begin
      moved := splitend - splitstart;
      if (lineend + 1) < splitstart then
      begin                             { line is below the split }
         for bindex := (splitstart-1) downto (lineend+1) do
            datawords[bindex + moved] := datawords[bindex];
         splitend := lineend + 1 + moved;
         splitstart := lineend + 1
      end
      else if (lineend + 1) > splitstart then
      begin                             { line is above the split }
         for bindex := splitend to lineend do
            datawords[bindex - moved] := datawords[bindex];
         splitend := lineend + 1;
         linestart := linestart - moved;
         lineend := lineend - moved;
         splitstart := lineend + 1
      end
   end
end;

{ Expand the split in the current block to be >= length }

function expandsplit( length: integer): boolean;                                { expandsplit }

var
   windex: datawordsrange;
   start: integer;
   lastnl: datawords0range;
   newblockaddress: ptrfileblock;
   insertedok: boolean;

   function insertnewblock: boolean;    { insert empty block after current }
   var
      iindex: 1..indexmax;
   begin
      if blocks = indexmax
      then insertnewblock := false
      else
      begin
         for iindex := blocks downto (indexsub + 1) do
            index[iindex + 1] := index[iindex];
         blocks := blocks + 1;
         new(newblockaddress);
         index[indexsub + 1].blockad := newblockaddress;
         insertnewblock := true
      end
   end;

begin

   { First shift part above split (if any) into a new block }

   if blockaddress^.splitend <= blockmaxwords then
   begin
      insertedok := insertnewblock;
      if insertedok then
      begin
         start := blockaddress^.splitend;
         for windex := start to blockmaxwords do
            newblockaddress^.datawords[windex - start + 1] :=
               blockaddress^.datawords[windex];
         with newblockaddress^ do       { tidy up new block }
         begin
            splitstart := blockmaxwords - start + 2;
            splitend := blockmaxwords + 1;   { not split }
            index[indexsub + 1].blocklines :=
               countlines(datawords, 1, splitstart-1, lastnl);
         end;
         with blockaddress^ do          { tidy up old block }
         begin
            splitend := blockmaxwords + 1;   { not split }
            index[indexsub].blocklines :=
               countlines(datawords, 1, splitstart-1, lastnl)
         end
      end
   end
   else insertedok := true;             { worked ok so far }

   { If there is still not enough room, try for space in next block }

   if ( (blockmaxwords+1 - blockaddress^.splitstart ) < length )   { room? }
      and insertedok                    { previous stage worked }
      and (indexsub < blocks) then      { next block exists }
   begin
      newblockaddress := index[indexsub + 1].blockad;
      with newblockaddress^ do
      begin
         if splitend <> (blockmaxwords + 1) then
            halt('New block already split');
         if (blockmaxwords + 1 - splitstart) >= length then   { room? }
         begin
            linesabove := linesabove + index[indexsub].blocklines;
            indexsub := indexsub + 1;
            blockaddress := newblockaddress;
            lineend := 0;               { move the split to end of block }
            movesplit
         end
      end
   end;

   { If still not enough room then overflow into a new block }

   if insertedok                        { ok so far }
   then
      if (blockmaxwords+1 - blockaddress^.splitstart ) < length then
      begin
         if insertnewblock then
         begin
            linesabove := linesabove + index[indexsub].blocklines;
            indexsub := indexsub + 1;
            blockaddress := newblockaddress;
            with blockaddress^ do
            begin
               splitstart := 1;
               splitend := blockmaxwords + 1
            end;
            index[indexsub].blocklines := 0;
            expandsplit := true         { now enough room }
         end
         else expandsplit := false      { insert failed this time }
      end
      else expandsplit := true          { already enough room }
   else expandsplit := false            { insert failed first time }
end;

{ Copy the current line into the split in the current block }

procedure copyoutline;                                                          { copyoutline }

var
   lindex, length: linewordsrange;
   splitstartm1: datawords0range;
   splitok: boolean;

begin
   filealtered := true;                 { file has now been changed }
   compressline(length);                { compress spaces }
   movesplit;                           { ensure split below current line }
   blockaddress^.splitstart := linestart;   { remove old version of line }

   { If the split in the current block is not long enough then
     expand it - this may change the current block }

   if (blockaddress^.splitend - blockaddress^.splitstart) < length then
   begin
      with index[indexsub] do           { update in case indexsub changed }
         blocklines := blocklines - 1;  { one line removed from block }
      splitok := expandsplit(length);
      if splitok then
      with index[indexsub] do
         blocklines := blocklines + 1   { one line replaced in block }
      else
      begin
         mainstate := commanderror;
         writeln('The editor workfile is full - line lost.')
      end
   end
   else splitok := true;

   if testing then with blockaddress^ do
      writeln('copyoutline: splitstart = ',splitstart:1,
                            ' splitend = ',splitend:1,
                              ' length = ',length:1);

   if splitok then
   with blockaddress^ do
   begin
      splitstartm1 := splitstart - 1;
      for lindex := 1 to length do
         datawords[lindex + splitstartm1] := compressedline.linewords[lindex];
      linestart := splitstart;          { new line position in block }
      lineend := splitstart + length - 1;
      splitstart := lineend + 1;
      if testing then
         writeln('copyoutline: splitstart = ',splitstart:1,
                               ' splitend = ',splitend:1)
   end
end;

{ Delete the current block if it is empty, but leave at least one block
  in the index }

function deleteifempty: boolean;                                                { deleteifempty }

var
   bindex: 1..indexmax;

begin
   if (index[indexsub].blocklines = 0) and
      (blocks > 1) then
   begin
      dispose(index[indexsub].blockad);     { delete the block }
      blocks := blocks - 1;
      for bindex := indexsub to blocks do   { move index to correspond }
         index[bindex] := index[bindex + 1];
      deleteifempty := true
   end
   else deleteifempty := false
end;

{ Move back to previous file block in index }

function getpreviousblock: boolean;                                             { getpreviousblock }

var
   deleted: boolean;

begin
   if indexsub = 1
   then getpreviousblock := false       { top of file }
   else
   begin
      deleted := deleteifempty;
      indexsub := indexsub - 1;
      lastlineinblock := linesabove;
      linesabove := linesabove - index[indexsub].blocklines;
      blockaddress := index[indexsub].blockad;
      getpreviousblock := true
   end
end;

{ Move on to next file block in index.  Only tests for user hitting BREAK in
  the situation where it has to read in a file block. }

function getnextblock( var userquit: boolean): boolean;                         { getnextblock }

var
   done, deleted: boolean;

begin
   userquit := false;                   { returned as true if breakin when }
                                        { reading file block i.e. a time }
                                        { consuming operation }
   done := false;
   deleted := deleteifempty;
   if deleted
   then  if indexsub <= blocks
         then  done := true             { indexsub already correct }
         else
         begin                          { it was last block in index }
            indexsub := indexsub - 1;   { move back to previous ... }
            linesabove := linesabove - index[indexsub].blocklines;
            deleted := false            { and pretend not deleted }
         end;
   if not done
   then  if indexsub < blocks then      { next block already read from file }
         begin
            indexsub := indexsub + 1;
            done := true
         end
         else  if mainfile.open
               then  if indexsub < indexmax then
                     begin              { read next block from file }
                        indexsub := indexsub + 1;
                        blocks := blocks + 1;
                        readnewblock(mainfile);
                        done := true;
                        userquit := mainstate = quitsignal
                     end
                     else
                     begin              { no space left in index }
                        writeln('The editor workfile is full');
                      { closefile(mainfile); }
                        mainstate := commanderror
                     end;

   { set details of new block }

   if done and (not deleted)
   then  linesabove := linesabove + index[indexsub-1].blocklines;
   { do next part even if "done" is false because of awkward cases such
     as reading zero words into last block at eof }
   with index[indexsub] do
   begin
      lastlineinblock := linesabove + blocklines;
      blockaddress := blockad
   end;
   getnextblock := done
end;

{ Find the file block which contains a given line number and set it
  up as the current block }

procedure findblock( number: integer;                                           { findblock }
               var atbottom: boolean);

var
   localsearch: searchtype;
   userquit: boolean;

begin
   if not deleteifempty                 { delete the block if it is empty }
   then closesplit;

   { look down the list of blocks }

   indexsub := 1;
   linesabove := 0;
   lastlineinblock := index[1].blocklines;
   blockaddress := index[1].blockad;
   localsearch := searching;
   repeat
      if number <= lastlineinblock
      then localsearch := found
      else if getnextblock(userquit)
      then if userquit                  { still searching }
           then localsearch := found    { dropout on quit }
           else
      else localsearch := notfound      { no more blocks }
   until
      localsearch <> searching;
   atbottom := localsearch = notfound
end;

{ Find the start and end of a line in the current block.
  Sets 'linestart' and 'lineend'. }

procedure findlineplace( newnumber: integer);                                   { findlineplace }

var
   lineno: integer;

begin
   with blockaddress^ do
   begin
      lineend := 0;
      for lineno := (linesabove + 1) to newnumber do
      begin
         linestart := lineend + 1;
         lineend := linestart;
         findnextnewline(datawords, lineend, linestart, false)
      end
   end
end;

{ Copy a line from workfile into current line buffer, expanding spaces }

procedure copyinline;                                                           { copyinline }

var
   lastcharind, fileindex: datacharsrange;
   incount, spacecount: integer;
   ch: char;
   compspaces: boolean;

   procedure copyinchar(ch: char);
   begin
      incount := incount + 1;
      if incount <= linemaxchars
      then line[incount] := ch
   end;

begin
   incount := 0;
   with blockaddress^ do
   begin
      lastcharind := lineend*2 - 1;     { end of line }
      if datachars[lastcharind] <> newline then
         lastcharind := lastcharind + 1;
      compspaces := false;
      for fileindex := (linestart*2 - 1) to lastcharind do
      begin
         ch := datachars[fileindex];
         if compspaces then             { expand compressed spaces }
         begin
            for spacecount := 1 to ord(ch) do
               copyinchar(' ');
            compspaces := false
         end
         else  if ch = dc1              { test for space suppression ch }
               then compspaces := true
               else copyinchar(ch)
      end
   end;
   if incount > linemaxchars then       { set up current line details }
   begin
      linelength := linemaxchars - 1;
      line[linemaxchars] := newline
   end
   else linelength := incount - 1;
   if linelength > testlinesize         { test length against LINESZ value }
   then writeln('Long line in file - line ',linenumber:1,' is ',
                incount-1:1,' characters long.');
   linealtered := false;
   lineexists := true
end;

{ Locate a given string (specified by start and stop char positions) in a given
  file block (ditto). Upper/lower case may or may not be significant }

function locatestringinblock( var block: datacharstype;                         { locatestringinblock }
                          bstart, bstop: datacharsrange;
                             var string: linecharstype;
                          var lowstring: linecharstype;
                          sstart, sstop: linecharsrange;
                              backwards: boolean;
                             casesignif: boolean;
                                var fcp: datacharsrange): boolean;

var
   innersearch, outersearch: searchtype;
   lastpossible, index, stopat: integer;
   lindex: linecharsrange;
   increment: -1..1;
   possible: boolean;
   firstch, firstup, firstlow, ch: char;

begin
   lastpossible := bstop - (sstop - sstart);
   if backwards then
   begin                                { moving backwards }
      index := lastpossible;            { start at last possible place }
      increment := -1;
      stopat := bstart;
      possible := stopat <= index
   end
   else
   begin                                { moving forwards }
      index := bstart;                  { start at first possible place }
      increment := +1;
      stopat := lastpossible;
      possible := stopat >= index       { is a match possible at all? }
   end;

   { search for the string, moving forwards or backwards }

   if sstop < sstart then
      outersearch := found              { zero length string }
   else if possible then
   begin
      if casesignif then

      { case of string is significant }

      begin
         outersearch := searching;
         firstch := string[sstart];
         repeat
            if block[index] = firstch then
            begin                       { first char matches - try rest }
               if sstop = sstart then
                  innersearch := found  { string length one }
               else
               begin
                  innersearch := searching;
                  lindex := sstart + 1;
                  while innersearch = searching do
                     if string[lindex] = block[lindex - sstart + index]
                     then if lindex = sstop
                          then innersearch := found
                          else lindex := lindex + 1
                     else innersearch := notfound
               end
            end
            else innersearch := notfound;
            if innersearch = found
            then outersearch := found
            else  if index = stopat
                  then outersearch := notfound
                  else index := index + increment
         until outersearch <> searching
      end
      else

      { case is not significant }

      begin
         outersearch := searching;
         firstup := string[sstart];
         firstlow := lowstring[sstart];
         repeat
            ch := block[index];
            if (ch = firstup) or (ch = firstlow) then
            begin                       { first char matches - try rest }
               if sstop = sstart then
                  innersearch := found  { string length one }
               else
               begin
                  innersearch := searching;
                  lindex := sstart + 1;
                  while innersearch = searching do
                  begin
                     ch := block[lindex - sstart + index];
                     if (ch = string[lindex]) or (ch = lowstring[lindex])
                     then if lindex = sstop
                          then innersearch := found
                          else lindex := lindex + 1
                     else innersearch := notfound
                  end
               end
            end
            else innersearch := notfound;
            if innersearch = found
            then outersearch := found
            else  if index = stopat
                  then outersearch := notfound
                  else index := index + increment
         until outersearch <> searching
      end
   end
   else
   begin                                { no match was possible }
      outersearch := notfound;
      index := 1                        { to ensure fcp ok }
   end;
   locatestringinblock := outersearch = found;
   fcp := index
end;

{  ********************************************
   * HIGHER LEVEL EDITOR FILE SYSTEM ROUTINES *
   ******************************************** }

{ Set top of file as current 'line' }

procedure settotopoffile;                                                       { settotopoffile }

var
   atbottom: boolean;

begin
   findblock(0, atbottom);
   lineexists := false;
   linestart := 1;                      { no actual space in file }
   lineend := 0;
   linenumber := 1;
   linelength := 0;
   lineposition := 1;
   linestatus := top
end;

{ Copy current line back into the file if necessary }

procedure replaceline;                                                          { replaceline }

begin
   with blockaddress^ do
   if lineexists
   then  if linealtered then
         begin                          { file copy is not up to date }
            copyoutline;
            linealtered := false        { copy now ok }
         end
         else                           { no need to copy }
   else  if linestart <= lineend then   { Is there a copy in file? }
         begin
            if linestart = splitend then
            begin                       { deleted line is first after split }
               splitend := lineend + 1; { delete old copy of line }
               linestart := splitstart
            end
            else
            begin
               movesplit;               { move split to below line }
               splitstart := linestart; { delete old copy of line }
            end;
            lineend := linestart-1      { zero length in file }
         end
         else                           { no copy in file - top or bottom }
end;

{ Set up a given line number as the current line }

procedure loadaline( newnumber: integer;                                        { loadaline }
                         print: boolean);

var
   atbottom: boolean;
   lineno: integer;

   { find the previous line (i.e. the one before "linestart").
     assumes it exists (i.e. need to test specially for first line in block) }

   procedure loadprevious;

   var
      stopat: datawordsrange;

   begin
      with blockaddress^ do
      begin
         if linestart = splitend        { allow for split in block }
         then lineend := splitstart - 1
         else lineend := linestart - 1;
         linestart := lineend - 1;
         if linestart >= splitend       { if above split }
         then stopat := splitend        { then stop at top of split }
         else stopat := 1;              { else stop at beginning of block }
         findnextnewline(datawords, linestart, stopat, true);

         { if the found line is the first one above the split then the linestart
           position will be wrong ( there is no valid newline before it ) }

         if (lineend >= splitend) and   { line is above split }
            (linestart < splitend)      { found newline in or below split }
         then linestart := splitend     { line is first after split }
         else linestart := linestart + 1 { start is 1 after previous newline }
      end
   end;

   { find the current line in the block (i.e. the one starting at "linestart") }

   procedure loadcurrent;

   begin
      with blockaddress^ do
      begin
         if linestart = splitstart      { allow for split in block }
         then linestart := splitend;
         if linestart > lineend then    { not set up yet - maybe after delete }
         begin
            lineend := linestart;
            findnextnewline(datawords, lineend, linestart, false)
         end
         else                           { lineend is already set up }
      end
   end;

begin
   replaceline;                         { put current line back into file }
   lineposition := 1;
   if newnumber < 1 then
   begin                                { top of file }
      settotopoffile;
      if print then writeln('.top.')
   end
   else
   begin
      if (newnumber > linesabove) and
         (newnumber <= linesabove + index[indexsub].blocklines) then
      with blockaddress^ do
      begin                             { line is within current block }

         { test for various positions in current block }

         if newnumber = linesabove + 1 then
         begin                          { first line in block }
            if splitstart = 1
            then linestart := splitend
            else linestart := 1;
            lineend := linestart;
            findnextnewline(datawords, lineend, linestart, false)
         end
         else  if newnumber < linenumber { not first, but before current }
               then  for lineno := 1 to (linenumber - newnumber) do
                        loadprevious
         else
         begin                          { current or later in block }
            loadcurrent;
            for lineno := 1 to (newnumber - linenumber) do
            begin
               linestart := lineend + 1;
               loadcurrent
            end
         end;
         lineexists := true;            { set up the details of the line found }
         linenumber := newnumber;
         linestatus := normal;
         copyinline
      end
      else
      begin                             { not within current block }
         findblock(newnumber, atbottom);
         with blockaddress^ do
         if atbottom then
         begin                          { bottom of file }
            lineexists := false;
            linestart := splitstart;    { no copy in file }
            lineend := splitstart - 1;
            linenumber := lastlineinblock + 1;
            linelength := 0;
            linestatus := bottom;
            if print then writeln('.bottom.')
         end
         else
         begin                          { normal line in file }
            if mainstate = quitsignal   { if user quit then land on last }
            then newnumber := lastlineinblock;   { line in block }
            findlineplace(newnumber);
            lineexists := true;
            linenumber := newnumber;
            linestatus := normal;
            copyinline                  { copy line into buffer }
         end
      end
   end
end;

{ Locate a string in the file blocks.
  The string must not contain any of the editor special chars such
  as blanks and wild, and must not include runs of more then one
  space because of space packing in the file. }

procedure quicklocate( var string: linecharstype;                               { quicklocate }
                    var lowstring: linecharstype;
                    sstart, sstop: linecharsrange;
                        backwards: boolean;
                       casesignif: boolean;
                            print: boolean;
                         stopline: integer);

var
   fcp: datacharsrange;
   fwp: datawords0p1range;
   lastnl, ignore: datawords0range;
   startat, linesbefore: integer;
   userquit: boolean;
   state: (searching, found, attop, atbottom, atstopline);

   function findin( start, stop: datawords0p1range): boolean;
   begin
      if start > stop
      then  findin := false             { nowhere to look }
      else  findin :=
            locatestringinblock ( blockaddress^.datachars,
                                  start*2 - 1, stop*2,
                                  string, lowstring, sstart, sstop,
                                  backwards, casesignif, fcp)
   end;

begin
   replaceline;
   state := searching;
   if backwards then
   begin                                { move backwards in file }
      startat := linestart - 1;
      if findin(blockaddress^.splitend, startat)
      then state := found
      else
      begin
         if   startat >= blockaddress^.splitstart
         then startat := blockaddress^.splitstart - 1;
         if findin(1, startat)
         then state := found
         else
         begin
            closesplit;
            repeat
               if linesabove < stopline
               then  state := atstopline
               else  if getpreviousblock
               then  if findin(1, blockaddress^.splitstart-1)
                     then  state := found
                     else  if mainstate <> running then
                     begin
                        stopline := linesabove + 1;
                        state := atstopline
                     end
                     else
               else  state := attop
            until state <> searching
         end
      end
   end
   else                                 { move forwards in file }
   begin
      if stopline = 0                   { 0 => never stop on line number }
      then stopline := maxint;
      startat := lineend + 1;
      if findin(startat, blockaddress^.splitstart-1)
      then state := found
      else
      begin
         if   startat <  blockaddress^.splitend
         then startat := blockaddress^.splitend;
         if findin(startat, blockmaxwords)
         then state := found
         else
         begin
            closesplit;
            repeat
               if lastlineinblock >= stopline
               then  state := atstopline
               else  if getnextblock(userquit)
               then  if findin(1, blockaddress^.splitstart-1)
                     then  state := found
                     else  if mainstate <> running then
                     begin
                        stopline := lastlineinblock;
                        state := atstopline
                     end
                     else
               else  state := atbottom
            until state <> searching
         end
      end
   end;

   case state of
      found:
         with blockaddress^ do
         begin                          { set up the details of line found }
            fwp := (fcp + 1) div 2;     { word position }
            if fwp < splitstart
            then  linesbefore := countlines(datawords,1,fwp-1,lastnl)
            else  linesbefore := countlines(datawords,1,splitstart-1,ignore)
                               + countlines(datawords,splitend,fwp-1,lastnl);
            linenumber := linesabove + linesbefore + 1;
            findnextnewline(datawords, fwp, fwp, false);
            linestart := lastnl + 1;
            lineend := fwp;
            lineexists := true;
            linestatus := normal;
            copyinline;
            lineposition := 1;

            { we have found a line, but it may be beyond the stop line }

            if (not backwards and (linenumber <= stopline)) or
               (    backwards and (linenumber >= stopline))
            then                        { it is ok }
            else loadaline(stopline, print)
         end;
      attop:
         loadaline(0, print);
      atbottom:
         loadaline(maxint, print);
      atstopline:
         begin
            loadaline(0, false);        { go to top first because we do not }
            loadaline(stopline, print)  { have current line details }
         end
   end { case }
end;

{ Test whether we have hit top or bottom }

procedure testlinelandedon;                                                     { testlinelandedon }
begin
   case linestatus of
      top, bottom:
         mainstate := toporbottom;
      normal:
   end
end;

{ Insert a new line into the work file }
{ Procedure is:
   1) replaceline  (to ensure current line is in file )
   2) put new text into current line and set linelength
   3) insertaline
}

procedure insertaline;                                                          { insertaline }

begin
   if lineexists                        { set new line number }
   then linenumber := linenumber + 1;
   if markedline >= linenumber then
   begin                                { keep line mark up to date }
      markedline := markedline + 1;
      if testing
      then writeln('markedline = ', markedline:1)
   end;
   linestart := lineend + 1;            { file copy is zero length }
   lineexists := true;
   linealtered := false;                { file copy is ok }
   linestatus := normal;
   lineposition := 1;
   with index[indexsub] do              { add one to block line count }
      blocklines := blocklines + 1;     { must be done before copyoutline }
   copyoutline                          { copy into file }
end;

{ Delete the current line }

procedure deleteline;                                                           { deleteline }

begin
   if lineexists then
   begin
      lineexists := false;              { line no longer exists }
      filealtered := true;              { file has been changed }
      if markedline <> 0                { keep line mark up to date }
      then if markedline > linenumber then
      begin
         markedline := markedline - 1;  { one line deleted }
         if testing
         then writeln('markedline = ', markedline:1)
      end
      else if markedline = linenumber then
      begin
         markedline := 0;               { marked line no longer exists }
         if testing
         then writeln('markedline = ', markedline:1)
      end;
      with index[indexsub] do
         if blocklines <= 0
         then halt('deleteline: no lines in block')
         else blocklines := blocklines - 1  { count one line deleted }
   end
end;

{ Load the named file into the editor workfile }

function loadafile(var pf: primosfile):boolean;                                 { loadafile }

var
   linenumberbefore, lastlineread: integer;

begin
   replaceline;                         { ensure line copied to file }
   with pf do
   begin
      openfile(k$read, pf);
      if open then
      begin
         loadafile := true;             { opened ok }
         if lineexists
         then linenumberbefore := linenumber
         else linenumberbefore := linenumber - 1;
         movesplit;                     { ensure split is below current line }
         readablock(pf, lastlineread);
         while open and (mainstate = running) do
         begin
            if expandsplit(blockmaxwords)
            then readablock(pf, lastlineread)
            else
            begin
               writeln('The Editor workfile is full.');
               mainstate := commanderror
            end
         end;
         closefile(pf);                 { in case of error or quit }
         lastlineread := lastlineread + linesabove;  { actual number }
         { go to top first because we do not have current line information }
         loadaline(0, false);
         loadaline(lastlineread, false);
         filealtered := true;
         if markedline > linenumberbefore then
         begin
            markedline := markedline +
               (lastlineread - linenumberbefore);
            if testing
            then writeln('markedline = ', markedline:1)
         end
      end
      else loadafile := false
   end
end;

{ Write a character as its octal representation }

procedure writechoctal(ch: char);                                               { writechoctal }

var
   valu: integer;
   digitno: 1..3;
   digits: array[1..3] of char;

begin
   write(escapesymbol);
   valu := ord(ch);
   for digitno := 3 downto 1 do
   begin
      digits[digitno] := chr( (valu mod 8) + ord('0') );
      valu := valu div 8
   end;
   for digitno := 1 to 3 do
      write(digits[digitno])
end;

{ Write out a set of characters }

procedure writeset(theset: setofchar);                                          { writeset }

var
   ch: char;
   first: boolean;

begin
   write('[');
   for ch := char.min to char.max do
      if ch in theset then
      begin
         if first
         then first := false
         else write(' ');
         if ch in [chr(200b)..chr(237b), chr(377b)]
         then  writechoctal(ch)
         else  write(ch)
      end;
   writeln(']')
end;

{ Write out a character, allowing for all the editor special treatments }

procedure writechmode(ch: char);                                                { writechmode }

   procedure writech(testch, ch: char);
   begin
      if testch in printspecials
      then  if testch = escapesymbol
            then  write(ch, ch)         { print ^ as ^^ }
            else  writechoctal(ch)      { specials as ^nnn }
      else  write(ch)
   end;

begin
   if ord(ch) < 200b                    { parity off? }
   then  if modeckpar
         then writechoctal(ch)          { print as octal }
%checks off                             { ord out of range }
         else writech(chr( ord(ch) + 200b), ch)  { set parity }
%checks on
   else  writech(ch, ch)
end;

{ Print the current line }

procedure printline;                                                            { printline }

var
   lindex: linecharsrange;

begin
   if inwindowcode
   then                                 { do nothing if command obeyed from }
                                        { within window code }
   else
   case linestatus of
      top:    writeln('.top.');
      normal:
         if lineexists then
         begin
            if modenumber
            then write(linenumber:5, ':');
            for lindex := 1 to linelength do
               writechmode(line[lindex]);
            writeln
         end
         else writeln('.null.');
      bottom: writeln('.bottom.')
   end
end;

{ Do verification print }

procedure verifyprint;                                                          { verifyprint }

begin
   if modeverify and (linestatus = normal) and (mainstate = running)
   then printline
end;

{ Restore the current line to its state before it was changed }

procedure oopsproc;                                                             { oopsproc }

begin
   case linestatus of
      top, bottom: printline;           { print top or bottom }
      normal:
         begin
            filechanged := true;
            if not lineexists then      { restoring deleted line}
            begin
               with index[indexsub] do
                  blocklines := blocklines + 1;  { one more line in block }
               if markedline >= linenumber then
               begin
                  markedline := markedline + 1;
                  if testing
                  then writeln('markedline = ', markedline:1)
               end
            end;
            if lineend < linestart
            then halt('oopsproc: restoring a null line');
            copyinline;
            verifyprint
         end
   end { case }
end;

{ Read the tokens (if any) on the command line }

function readtokens: boolean;                                                   { readtokens }

type
   infotype = packed array[1..8] of shortint;  { rdtk$$ info array }

var
   info: infotype;
   info1: integer;
   code: shortint;
   iostate: integer;
   inittreename, token: treestring;
   nextismainfile, nextisinitfile: boolean;
   finished, worked: boolean;
   ch: char;

   procedure rdtk$$( key: shortint;
                var info: infotype;
              var buffer: treestring;
                  buflen: shortint;
                var code: shortint); extern;

begin
   editmodeafterinit := false;
   mainfile.treelength := 0;
   initfileopen := false;
   nextismainfile := true;              { expect main file name first }
   nextisinitfile := false;
   setuponunit := true;                 { normally set up quit on-unit }
   enterwindow := false;                { do not normally enter wi }
   testing := false;                    { not testing }
   worked := true;                      { assume success }

   finished := false;
   repeat
      rdtk$$(short(1), info, token, short(treemaxwords), code);
      errpr$(k$nrtn, code, token, short(0), 'RDTK$$', short(6) );
      info1 := long(info[1]);
      if info1 = 6
      then finished := true             { end of command line }
      else if info1 <> 1
      then                              { ignore register setting and null }
      else
      begin                             { normal token }
         if token[1] = '-' then
         begin
            nextismainfile := false; { no main file name given }
            nextisinitfile := false;
            ch := token[2];
            if ch = 'I'              { -INIT }
            then nextisinitfile := true
            else if ch = 'T'         { -TEST }
            then testing := true
            else if ch = 'N'         { -NOUNIT }
            then setuponunit := false
            else if ch = 'W'         { -WINDOW }
            then enterwindow := true
            else worked := false { not recognised }
         end
         else if nextismainfile then
         begin                       { it is main file treename }
            mainfile.treelength := long(info[2]);
            mainfile.treename := token;
            editmodeafterinit := true;
            nextismainfile := false
         end
         else if nextisinitfile then
         begin                       { it is -INIT file treename }
            reset(input, token);
            getios(iostate);         { did it work? }
            if iostate <> 0 then
            begin
               errpr$(k$irtn, short(iostate), token, short(0),
                      'TSRC$$', short(6));
               writeln('Failed to open -init file');
               worked := false
            end
            else
            begin
               initfileopen := true;
               nextisinitfile := false
            end
         end
         else worked := false        { what is it? }
      end
   until finished;
   readtokens := worked
end;

{ Open the file given (if any) and set up the work file }

function setupworkfile: boolean;                                                { setupworkfile }

var
   worked: boolean;

begin
   worked := true;
   blocks := 1;
   indexsub := 1;
   with mainfile do
   begin
      if editmodeafterinit then
      begin                             { EDIT - open file }
         openfile(k$read, mainfile);
         if open then
         begin
            readnewblock( mainfile );
            settotopoffile
         end
         else
         begin                          { failed to open main file }
            worked := false;
            setupemptyblock
         end
      end
      else
      begin
         setupemptyblock;               { INPUT - empty workfile }
         open := false;
         settotopoffile
      end
   end;
   if worked
   then
      if initfileopen
      then editmode := true             { always obey init file in edit mode }
      else
      begin
         editmode := editmodeafterinit; { set correct mode }
         if editmode then writeln('Edit') { inform user now }
                     else writeln('Input')
      end;
   setupworkfile := worked
end;

{ Read tokens and set up editor workfile }

function initialise: boolean;                                                   { initialise }

begin
   if not readtokens then
   begin
      writeln('Error in parameters.');
      initialise := false
   end
   else initialise := setupworkfile
end;

{ Clear out the blocks in the workfile }

procedure emptyworkfile;                                                        { emptyworkfile }

var
   iindex: 1..indexmax;

begin
   for iindex := 1 to blocks do
      dispose(index[iindex].blockad)
end;

{ Perform a file or save operation }

function fileorsave( var pfile: primosfile): boolean;                           { fileorsave }

var
   ok, finished: boolean;

begin
   fileorsave := false;
   loadaline(maxint, false);            { go to bottom to ensure all read in
                                          and file unit closed }
   if mainstate = running then
   begin                                { user has not quit }
      openfile(k$writ, pfile);          { open the file }
      if pfile.open then
      begin
         indexsub := 1;
         finished := false;
         repeat
            writeablock( pfile, ok);
            if indexsub < blocks
            then indexsub := indexsub + 1
            else finished := true
         until finished or (not ok);
         closefile(pfile);              { close the file }
         if ok
         then filealtered := false;     { file copy now ok }
         fileorsave := ok
      end
   end
end;

{ Get a yes or no answer to a question }

function yesorno: boolean;                                                      { yesorno }

var
   answer: word;
   ch: char;
   ok: boolean;

begin
   repeat
      readln(answer);
      ch := answer[1];
      ok := ch in ['Y','y','N','n',' '];
      if not ok then write('Please answer yes or no: ')
   until ok;
   yesorno := ch in ['Y', 'y', ' ']
end;

{ Write the current line out to the loadfile for UNLOAD and DUNLOAD }

function unloadline: boolean;                                                   { unloadline }

var
   rnw, code: shortint;

begin
   if lineexists then
   with loadfile, blockaddress^ do
   begin
      replaceline;                      { ensure file copy up to date }
      prwf$$(k$writ, unit, addressof(datawords[linestart]),
             short(lineend-linestart+1), 0, rnw, code);
      errpr$(k$irtn, code, treename, short(treelength), 'PRWF$$', short(6) );
      unloadline := long(code) = 0
   end
   else unloadline := true
end;

{ Unload the lines from startline to stopline inclusive by writing the
  appropriate parts of the file blocks directly }

function quickunload(startline, stopline: integer): boolean;                    { quickunload }

var
   rnw, code: shortint;
   startindex, stopindex, bindex: 1..indexmax;
   startad, stopad, ad1, ad2: datawordsrange;
   done, ok: boolean;

begin
   loadaline(0, false);                 { ensure split closed }
   loadaline(startline, false);         { collect start and stop file block }
   startindex := indexsub;              { information }
   startad := linestart;
   loadaline(stopline, false);
   stopindex := indexsub;
   stopad := lineend;

   bindex := startindex;                { loop through the blocks }
   ad1 := startad;                      { start at line start in first block }
   done := false;
   ok := true;
   if mainstate = running then
   repeat
      with loadfile, index[bindex], blockad^ do
      begin
         if bindex = stopindex then
         begin
            ad2 := stopad;              { stop at line end }
            done := true
         end
         else ad2 := splitstart - 1;    { or end of block }
         prwf$$(k$writ, unit, addressof(datawords[ad1]),
                short(ad2 - ad1 + 1), 0, rnw, code);
         if long(code) <> 0 then
         begin
            errpr$(k$irtn, code, treename, short(treelength),
                   'PRWF$$', short(6));
            ok := false
         end;
         ad1 := 1;                      { start at word 1 for later blocks }
         if not done
         then bindex := bindex + 1
      end
   until
      done or (not ok) or (mainstate <> running);
   quickunload := ok
end;

{ Delete the lines from startline to stopline inclusive by altering and
  deleting file blocks directly.  Leaves the current line as the one after
  the last line deleted }

procedure quickdelete(startline, stopline: integer);                            { quickdelete }

var
   down: integer;
   startindex, stopindex, iindex: 1..indexmax;
   startad, stopad, windex: datawords0p1range;

begin
   if stopline < startline
   then                                 { nothing to delete }
   else
   begin
      loadaline(0, false);              { ensure split closed }
      loadaline(startline, false);      { gather start and stop information }
      startindex := indexsub;
      startad := linestart;
      loadaline(stopline, false);
      if linestatus = bottom then       { at .bottom. back up one line }
      begin
         stopline := linenumber - 1;
         loadaline(stopline, false)
      end;
      stopindex := indexsub;
      stopad := lineend;

      if mainstate = running then
      begin
         filealtered := true;
         if markedline >= startline then  { keep markedline up to date }
         begin
            if markedline <= stopline
            then markedline := 0        { it no longer exists }
            else markedline := markedline -  { subtract lines gone }
                    (stopline -startline + 1);
            if testing
            then writeln('markedline = ', markedline:1)
         end;

         { go through blocks from last to first because we can alter blocks and
           still get the correct "linesabove" information. }

         { deal with first part of last block }

         with index[indexsub], blockad^ do
         begin
            if indexsub = startindex then
            begin                       { all in one block }
               down := stopad + 1 - startad;
               blocklines := blocklines - (stopline - startline + 1)
            end
            else
            begin                       { remove first part of last block }
               down := stopad;
               blocklines := blocklines - stopline + linesabove
            end;
            { copy remaining words to front of block }
            for windex := (stopad + 1) to (splitstart - 1) do
               datawords[windex - down] := datawords[windex];
            splitstart := splitstart - down
         end;

         { completely remove intermediate blocks if any }

         for iindex := (stopindex - 1) downto (startindex + 1) do
         begin
            if not getpreviousblock
            then halt('quickdelete: no previous block');
            dispose(index[indexsub].blockad)
         end;

         { truncate first block at startline position }

         if indexsub <> startindex then
         begin
            if not getpreviousblock
            then halt('quickdelete: no previous block');
            with index[indexsub], blockad^ do
            begin
               splitstart := startad;
               blocklines := startline - linesabove - 1
            end
         end;

         { remove deleted blocks from index }

         down := stopindex - startindex - 1;
         if down > 0 then
         begin
            for iindex := stopindex to blocks do
               index[iindex - down] := index[iindex];
            blocks := blocks - down
         end;

         loadaline(0, false);           { go to top first because we do not }
                                        { current line information }
         loadaline(startline, false)    { was numbered "stopline" before }
      end
   end
end;

{---stop---}

begin                                   { dummy main program }
end.
