%ecs = true
{ Convert a file to all one printable char, leaving LF and space suppression }
{ alone, so that we can see the wood, not the trees. }

PROGRAM convert_bugfile (input, output);

type
   char2 = packed record
      ch1, ch2: char
   end;

var
   entry: char2;
   infile, outfile: file of char2;
   ch: char;
   leave_next: boolean;
   count: integer;

   procedure process(var the_char: char; is_left: boolean);

   begin { process }
      if leave_next
      then leave_next := false          { leave this one unchanged }
      else if the_char = chr(212b)      { newline }
      then leave_next := is_left
      else if the_char = chr(221b)      { space suppress }
      then leave_next := true
      else the_char := '-'
   end { process } ;

begin { convert_bugfile }
   reset(infile,'BUGFILE');
   rewrite(outfile,'BUGFILE.NEW');
   leave_next := false;
   count := 0;
   while not eof(infile) do
   begin
      read(infile,entry);
      count := count + 1;
      with entry do
      begin
         ch := ch1;
         process(ch, true);
         ch1 := ch;
         ch := ch2;
         process(ch, false);
         ch2 := ch
      end { with } ;
      write(outfile,entry)
   end { while loop } ;
   writeln(count:1,' words in file.')
end { convert_bugfile } .
