      subroutine hook8(vdutyp)
      integer*4 vdutyp
C
C Decide which type of terminal the user has.  We send ESC ?  to get the
C current cursor position (some BBCs do not respond to this  code).   We
C then  send  ESC  =  r c to set the cursor onto row 25, col 1;  this is
C legal on the BBC which has at  least  25  rows,  but  illegal  on  the
C others.  We then read the cursor location and the response is:
C    1   Televideo 920   Row 1
C    2   Merlin          Row 24
C  3/4   BBC40/80        Row 25
C
C Code is actually more complex than described above. We now send
C
C
C    ESC I Q ? T ESC ?
C
C The ESC ? acts as above and the above terminals ignore the ESC I Q ? T.
C The Pericom MX4000 and Tektronix 4107 reply  ? T $   ; which does not
C match any of the other terminals' responses.
C
$insert syscom>keys.ins.ftn
      intrinsic or, intl
      external tty$rs, errpr$, t1ou, t1in, sleep$, tonl, tnou
      external duplx$, tty$in, mkon$f
      external tmsecs, quiton
      integer*2 duplx$, tty$in
      integer*2 record, count, dummy, chars(3), ch1, ch2, ch3, code
      integer*2 errors
      integer*4 start, finish, now, interv
      logical extra, gotloc
      parameter (interv = 30000)        /* wait 30 secs for answer
      common /hk8q/ quittd
      logical quittd
      quittd = .false.
C
      call mkon$f('QUIT$', 5, quiton)
      errors = 0
      gotloc = .false.                  /* true after correctly reading loc
      record = duplx$(-1)
      dummy = duplx$(or(record,:140000))   /* echo off
C
C Clear input buffer and send ESC I Q ? T (which is an invitation to
C Tektronix 4107 and compatible Pericom MXx000's to identify themselves)
C followed by ESC ?, which is "read cursor location" for other terminals.
C
50    if(gotloc) go to 405              /* already got valid cursor loc
      call tty$rs(:040000, code)        /* clear input
      call errpr$(k$nrtn,code,'Clearing input buffer',21,'TTY$RS',6)
      call t1ou(:233)                   /* ESC
      call t1ou(:311)                   /* I
      call t1ou(:321)                   /* Q
      call t1ou(:277)                   /* ?
      call t1ou(:324)                   /* T
      call t1ou(:233)                   /* ESC
      call t1ou(:277)                   /* ?
      call tmsecs(start)
      finish = start + interv
      count = 0                         /* characters read
C
C Test whether any characters to read
C
100   if(tty$in().ge.0) go to 200
C
C Read char from terminal
C
      count = count + 1
      call t1in(chars(count))
      if(count.ge.3) go to 300
      go to 100
C
C Wait a while, unless time is up
C
200   if(quittd) go to 890              /* User quit
      call tmsecs(now)
      if(now.lt.start) now = start + 86400000  /* allow for midnight
      if(now.gt.finish) go to 300       /* time up
      call sleep$(intl(100))            /* wait 0.1 secs
      go to 100
C
C Look at number of characters read
C
300   if(count.eq.0) go to 900          /* No response
      if(count.eq.3) go to 400          /* Televideo or Merlin or BBC
      go to 960                         /* unknown
C
C Differentiate between Televideo, Merlin and BBC
C
400   if(chars(3).ne.:212) go to 500    /* third char should be LF
      gotloc = .true.
C
C Send ESC = 8 sp (set cursor to row 25, col 1)
C      ESC ?      (read cursor)
C Response is
C      spsp LF    (Televideo on row  1 col 1)
C      7 sp LF    (Merlin    on row 24 col 1)
C      8 sp LF    (BBC       on row 25 col 1)
C
405   call t1ou(:233)                   /* ESC
      call t1ou(:275)                   /* =
      call t1ou(:270)                   /* 8
      call t1ou(:240)                   /* space
      call t1ou(:233)                   /* ESC
      call t1ou(:277)                   /* ?
      extra = .false.
410   call t1in(ch1)
      if(ch1.ge.:240) go to 420
      extra = .true.                    /* extra character sent after response
      go to 410
420   call t1in(ch2)
      call t1in(ch3)
      if(extra) call t1in(dummy)        /* absorb second extra character
      if(ch3.ne.:212) go to 960         /* ch3 must LF
      if(ch2.ne.:240) go to 960         /* ch2 must be space
      if(ch1.eq.:240) go to 910         /* space space   Televideo
      if(ch1.eq.:267) go to 920         /* 7 space   Merlin
      if(ch1.eq.:270) go to 940         /* 8 space   BBC
      go to 960
C
C  Now check to see if it looks like a Tektronix 4107 compatible
C  which replies ? T $ BL ; LF
C
500   if(chars(1).ne.:277               /* ?
     x   .or. chars(2).ne.:324          /* T
     x   .or. chars(3).ne.:244          /* $
     x  ) go to 960
C
C  It looks OK so suck in the next three characters assuming them to
C  be BL ; LF
C
      call t1in(ch1)
      call t1in(ch1)
      call t1in(ch1)
C
C  Switch on character display at the Pericom/ Tek 4107 by sending
C  LF which is required because we are in half duplex.
C
      call t1ou(:212)
C
C  Terminal type 11
C
      vdutyp = 11
C
C  No screen fixup to do in this case
C
      go to 980
C
C Set terminal type discovered
C
890   vdutyp = -1                       /* User quit - probably some error
      go to 950
900   vdutyp = 0                        /* No response - unknown type
      go to 950
910   vdutyp = 1                        /* Televideo
      go to 950
920   vdutyp = 2                        /* Merlin
      go to 950
940   vdutyp = 4                        /* BBC
C
C Replace cursor at recorded position only if terminal responded
C
950   if(count.le.0) go to 980          /* There was no response
      call t1ou(:233)                   /* ESC
      call t1ou(:275)                   /* =
      call t1ou(chars(1))
      call t1ou(chars(2))
C
C The cursor is now at the wrong place due to the extra characters
C for the Tektronix - erase these - three would have printed.
C
      call t1ou(:210)                   /* Backspace
      call t1ou(:210)                   /* Backspace
      call t1ou(:210)                   /* Backspace
      call t1ou(:240)                   /* Space
      call t1ou(:240)                   /* Space
      call t1ou(:240)                   /* Space
      call t1ou(:210)                   /* Backspace
      call t1ou(:210)                   /* Backspace
      call t1ou(:210)                   /* Backspace
      go to 980
C
C Failed to recognise terminal this time - try again
C
960   errors = errors + 1
      if(errors.lt.10) go to 50         /* try again a few times
      vdutyp = 0
      call tonl
      call tonl
      call tnou('Unable to recognise the type of your terminal.',46)
      call tonl
      call tonl
C
C Switch echoing back on and exit
C
980   dummy = duplx$(record)
      return
      end
      subroutine tmsecs(tim)
      integer*4 tim
C
C Calculate time of day in MSECS
C
      intrinsic intl
      external timdat
      integer*2 tdinfo(28)
      integer*2 mm,ss,ticks,tpers
      equivalence
     x    (tdinfo( 4), mm),
     x    (tdinfo( 5), ss),
     x    (tdinfo( 6), ticks),
     x    (tdinfo(11), tpers)
      call timdat(tdinfo,28)
      tim = (intl(mm)*60+intl(ss))*1000 + intl(ticks)*1000 / intl(tpers)
      return
      end
      subroutine quiton(cfptr)
      integer*4 cfptr
C
C On-unit for QUIT$
C
      common /hk8q/ quittd
      logical quittd
      quittd = .true.
      return
      end
