program main ( input , output , libfile ) ;
const
   magiclocation = 279 { 1st word in file is word number 1 - c.f. FILEPR };
   a = 29 ; b = 7 ; c = 128;
   atimescminus1 = 3683;
   libfilename = 'PMED_BITS.BIN';
type
   magicnumber = 0..32767;
   magicdomain = 0..127;
   magicvector = array [1..5] of magicnumber;
var
   libfile : packed file of 0..177777b;
   newmagic : magicvector;

function consistent ( magic : magicvector ) : boolean ;
   var
      stillconsistent : boolean;
      i : 1..3;

   function checkvalue ( magic : magicvector ) : magicnumber ;
      var
         m : magicnumber;
         i : 1..3;
      begin
         m := 0;
         for i := 1 to 3 do
            m := 32 * m + magic[i] div 16 mod 32;
         checkvalue := m
      end { checkvalue };

   begin { consistent }
      stillconsistent := true;
      for i := 1 to 3 do
         if magic[i] div 128 <> magic[5] mod 256
         then stillconsistent := false;
      consistent := stillconsistent and (magic[4] = checkvalue(magic))
   end { consistent };

procedure getmagic ( var magic : magicvector ) ;

   var
      customer , n : magicnumber;
      i : 1..4;
      answer : alfa;
   begin
      write('Identifier: ');
      customer := 0;
      if input^ in ['C','c'] then
      begin
         get(input);
         if input^ in ['0'..'9']
         then read(customer)
      end;
      readln;
      open(libfile,libfilename);
      seek(libfile,magiclocation+4);
      get(libfile) ; n := libfile^;
      close(libfile);
      if customer <> n
      then halt('Identifier not found');
      magic[5] := customer;
      writeln('Type in numbers supplied by distributor...');
      for i := 1 to 4 do
      begin
         write(i:1,': ');
         readln(magic[i])
      end;
      writeln;
      write('Numbers are: ',magic[1]:1);
      for i := 2 to 4 do write(', ',magic[i]:1);
      writeln;
      writeln;
      write('OK to continue? (Y/N): ');
      readln(answer);
      if not (answer[1] in ['Y','y'])
      then halt('Program aborted');
      if not consistent(magic) then
      begin
         writeln('These numbers are inconsistent - contact your distributor.');
         halt('Inconsistent input')
      end
   end { getmagic };

procedure changemagic ( libname : string; newmagic : magicvector ) ;
   var
      oldmagic : magicvector;
      i : 1..5;
   begin
      open(libfile,libname);
      seek(libfile,magiclocation);
      get(libfile);
      for i := 1 to 5 do read(libfile,oldmagic[i]);
      if not consistent(oldmagic) then
      begin
         writeln('System contains invalid data - contact your distributor.');
         halt('Invalid data')
      end;
      seek(libfile,magiclocation);
      for i := 1 to 4 do write(libfile,newmagic[i])
   end { changemagic };

begin
   getmagic(newmagic);
   changemagic(libfilename,newmagic)
end.
