%separate = true
%ecs = true
%ttybuffered = false
%epfargs = true
{ Sheffield University Editor }
{ Copyright (c) University of Sheffield 1990 }

{*********************************************************************}
{ EDITOR FILING SYSTEM AND ROUTINES COMMON TO LINE AND WINDOW EDITORS }
{*********************************************************************}

subprogram pmed_efs;

%listing off
%insert pmed_globals.ins.pas
%insert pmed_procs.ins.pas
%insert pmed_vdu.ins.pas
%listing on

procedure attach_home;                                                          { ATTACH_HOME }

var
   code: shortint;

   procedure at$hom(var code: shortint);
      extern;

begin { attach_home }
   at$hom(code)
end { attach_home } ;

{ Call SRSFX$ to open a file }

procedure call_srsfx$(key: shortint;                                            { CALL_SRSFX$ }
                      pathname: tree_string;
                      var unit, tipe, code: shortint);

var
   base_name: string32;
   suffix_used: shortint;

begin { call_srsfx$ }
   srsfx$(key, pathname, unit, tipe, 0, '', base_name, suffix_used, code)
end { call_srsfx$ } ;

{ Call SRSFX$ to close a file }

procedure close_unit(the_unit: shortint; var code: shortint);                   { CLOSE_UNIT }

var
   tipe: shortint;

begin { close_unit }
   call_srsfx$(k$clos, '', the_unit, tipe, code)
end { close_unit } ;

{***************************************}
{ EDITOR FILE SYSTEM LOW LEVEL ROUTINES }
{***************************************}

{---teststart---}

{ procedures (for calling from DBG ) to print diagnostics }

procedure dbg_print;                                                            { DBG_PRINT }

label 221;

type
   ptr_type = (pbuffer, pindex, pblock);
   all_ptrs = record
      case ptr_type of
         pbuffer: (the_buffer: ptr_buffer_info);
         pindex:  (the_index: ptr_index_block);
         pblock:  (the_block: ptr_file_block)
      end;

var
   buffer_no: integer;
   general_ptr: all_ptrs;
   done: boolean;

   procedure ioa$(ioa_text: char4;
                  length: shortint;
                  var1: all_ptrs);
      extern;

   procedure printchain(top_ptr: ptr_index_block);

   var
      temp_ptr: ptr_index_block;
      total: integer;

   begin { printchain }
      temp_ptr := top_ptr;
      if temp_ptr = nil
      then write('NIL')
      else
      begin { not nil }
         general_ptr.the_index := temp_ptr;
         ioa$('%p  ', 2, general_ptr);
         total := 0;
         while temp_ptr <> nil do
         with temp_ptr^ do
         begin
            total := total + top_entry;
            temp_ptr := next
         end;
         write(' (',total:1,')')
      end { not nil }
   end { printchain } ;

   procedure print_details(the_buffer: buffer_info);

   var
      temp_index: ptr_index_block;
      answer: word;
      testsub, on_count, off_count, index_number,
      index_first, index_last, block_first: integer;
      eindex: index_range;

   begin { print_details }
      with the_buffer do
      begin
         write('first_index = ');
         printchain(first_index);
         write('  current_index = ');
         general_ptr.the_index := current_index;
         ioa$('%p  ', 2, general_ptr);
         writeln;
         writeln('index_sub = ',index_sub:1,'  block_number = ',block_number:1,
                 '  blocks = ',blocks:1,'  memory_blocks = ',memory_blocks:1);
         writeln('lines_above = ',lines_above:1,
                 '  last_line_in_block = ',last_line_in_block:1);
         write('line_number = ',line_number:1,'  line_length = ',line_length:1,
               '  line_position = ',line_position:1,'  line_status = ');
         case line_status of
            top: writeln('top');
            normal: writeln('normal');
            bottom: writeln('bottom')
         end;
         writeln('line_exists = ',line_exists,'  line_altered = ',line_altered,
                 '  file_altered = ',file_altered);
         writeln('line_start = ',line_start:1,'  line_end = ',line_end:1);
         writeln('marked_line = ',marked_line:1,
                 '  iw_marked_line = ',iw_marked_line:1,
                 '  point_line_pos = ',point_line_pos:1,
                 '  point_line_no = ',point_line_no:1);
         with main_file do
         begin
            writeln('treename = "',treename.strng,'"');
            writeln('unit = ',unit:1,'  file_is_open = ',file_is_open,
                    '  original_pathname = ',original_pathname);
            writeln('rename_done = ',rename_done);
            writeln('file_type = ',file_type:1,
                    '  truncate_later = ',truncate_later,
                    '  prepos = ',prepos:1);
         end;
         temp_index := first_index;
         index_number := 0;
         index_first := 1;              { first file line number }
         while temp_index <> nil do
         begin
            with temp_index^ do
            begin
               index_number := index_number + 1;
               writeln('----------------------------------------');
               if temp_index = current_index
               then write(' ->  ')
               else write('     ');
               write('index number ',index_number:1,' = ');
               general_ptr.the_index := temp_index;
               ioa$('%p  ', 2, general_ptr);
               writeln;
               write('     previous = ');
               if previous = nil
               then write('NIL')
               else
               begin
                  general_ptr.the_index := previous;
                  ioa$('%p  ', 2, general_ptr)
               end;
               write('  next = ');
               if next = nil
               then write('NIL')
               else
               begin
                  general_ptr.the_index := next;
                  ioa$('%p  ', 2, general_ptr)
               end;
               writeln;
               write('     entries = ',top_entry:1,'/',index_max:1);
               off_count := 0;
               on_count := 0;
               index_last := index_first - 1;
               for eindex := 1 to top_entry do
               with entries[eindex] do
               begin
                  if entries[eindex].block_ad = nil
                  then off_count := off_count + 1
                  else on_count := on_count + 1;
                  index_last := index_last + block_lines
               end;
               writeln(' (',on_count:1,' in/',off_count:1,' out)');
               writeln('     line numbers ',index_first:1,' to ',index_last:1)
            end;
            write('--more?-- '); readln(answer);
            if compare(answer,'next    ') or compare(answer,'NEXT    ')
            then temp_index := temp_index^.next  { do not terminate }
            else if compare(answer,'yes     ') or compare(answer,'YES     ')
            then with temp_index^ do
            begin
               if temp_index = current_index
               then testsub := index_sub
               else testsub := 0;
               block_first := index_first;
               for eindex := 1 to top_entry do
               if main_state = running then
               with entries[eindex] do
               begin
                  write(eindex:4,' ',block_first:7);
                  block_first := block_first + block_lines;
                  if eindex = testsub
                  then write(' ->  ')
                  else write('     ');
                  write('(',block_lines:4,' , ');
                  if block_ad = nil
                  then write('     NIL      ')
                  else
                  begin
                     general_ptr.the_block := block_ad;
                     ioa$('%14p', 4, general_ptr);
                  end;
                  writeln(' , ',file_key:4,' , ',paged_out_copy_ok,' )',
                          '  (',split_start:4,' , ',split_end:4,' )')
               end;
               main_state := running;   { in case of quit }
               temp_index := next
            end
            else temp_index := nil;     { terminate loop }
            index_first := index_last + 1
         end { while loop }
      end { with }
   end { print_details } ;

   procedure onunit(not_used: integer);
   begin { onunit }
      if not eoln(input)
      then write('Press RETURN');
      readln;                           { clear away any rubbish }
      goto 221
   end { onunit } ;

begin { dbg_print }
   on('ERROR_TRAP', onunit);            { trap Pascal library errors }
   writeln('current_buffer_number = ',current_buffer_number:1,
           '  multiple_buffers_used = ',multiple_buffers_used);
   writeln('lowest_empty_buffer = ',lowest_empty_buffer:1);
   writeln('first_buffer_in_chain = ',first_buffer_in_chain:1,
           '  last_buffer_in_chain = ',last_buffer_in_chain:1);
   writeln('new_block_count = ',new_block_count:1,'/',new_block_max:1);
   write('free_blocks = ');
   printchain(free_blocks);
   write('  free_keys = ');
   printchain(free_keys);
   writeln;
   writeln('paging_file_open = ',paging_file_open,
           '  blocks_paged_out = ',blocks_paged_out:1,
           '  top_paging_key = ',top_paging_key:1);
   writeln('target_buffer_number = ',target_buffer_number:1,
           '  index_block_count = ',index_block_count:1,'/',index_block_max:1);
   done := false;
   repeat
      write('Buffer number (1..',buffer_max:1,') or 0 to finish: ');
      readln(buffer_no);
      if buffer_no = 0
      then done := true
      else if (buffer_no >= 1) and (buffer_no <= buffer_max) then
      with buffer_pointers[buffer_no] do
      begin { in range }
         write('pred_buff = ',pred_buff:1,'  succ_buff = ',succ_buff:1,
               '  bptr = ');
         general_ptr.the_buffer := bptr;
         ioa$('%p%.', 4, general_ptr);
         if buffer_no = current_buffer_number
         then print_details(current_buffer)
         else if buffer_pointers[buffer_no].bptr = nil
         then writeln('Buffer empty.')
         else print_details(bptr^)
      end { in range }
      else writeln('Out of range.')
   until done;
221:
end { dbg_print } ;

{---teststop---}

{ Move "wd_count" words from "from_string[fromsub]" to "to_string[tosub]". }
{ Preserves the words moved by copying either forwards or backwards.       }

   procedure movewds(from_string: data_words_type;
                     fromsub: integer;
                     var to_string: data_words_type;
                     tosub: integer;
                     wd_count: integer);
      extern;                           { written in PMA }

{ Obtain memory space for a file_block record }

function obtain_file_block(var the_buffer: buffer_info): ptr_file_block;        { OBTAIN_FILE_BLOCK }

var
   temp_entry: index_entry;
   free_segments: integer;

   { Get back a saved entry }

   procedure get_back_entry(var top_point: ptr_index_block;
                            var the_entry: index_entry);

   var
      temp_ptr: ptr_index_block;

   begin { get_back_entry }
      with top_point^ do
      begin
         the_entry := entries[top_entry];
         top_entry := top_entry - 1;
         if top_entry = 0 then
         begin
            temp_ptr := next;
            dispose(top_point);
            index_block_count := index_block_count - 1;
            top_point := temp_ptr
         end
      end { with }
   end { get_back_entry } ;

   { allocate a new key in the paging file }

   procedure allocate_key(var file_key: integer);

   var
      temp_entry: index_entry;
      current_time: alfa;
      nindex: 1..8;

   begin { allocate_key }
      if free_keys <> nil then
      begin { reuse old one saved on list }
         get_back_entry(free_keys, temp_entry);
         {---teststart---}
         if mode_test
         then writeln('re-using file key ',temp_entry.file_key:1);
         {---teststop---}
         file_key := temp_entry.file_key
      end { reuse old one saved on list }
      else
      begin
         if paging_file_open
         then top_paging_key := top_paging_key + 1
         else
         begin
            time(current_time);
            current_time[3] := '-';
            current_time[6] := '-';
            paging_file_name := 'T$.PAGINGFILE.hh-mm-ss';
            for nindex := 1 to 8
            do paging_file_name[nindex + 14] := current_time[nindex];
            open(paging_file, paging_file_name);
            paging_file_open := true;
            screen_message('Warning: The editor is starting to use its paging mechanism because of lack of', true);
            screen_message('         dynamic memory.  Please free some dynamic segments if possible.', true);
            {---teststart---}
            if mode_test
            then writeln('paging file opened as ',paging_file_name);
            {---teststop---}
            top_paging_key := 1
         end;
         {---teststart---}
         if mode_test
         then writeln('new file key is ',top_paging_key:1);
         {---teststop---}
         file_key := top_paging_key
      end
   end { allocate_key } ;

   { Page a block out onto the direct-access file }

   procedure page_out_block(var the_buff: buffer_info;
                            var the_entry: index_entry);

   label 232;

   var
      error_flag: boolean;

      procedure onunit(not_used: integer);

      var
         old_block_ad: ptr_file_block;

      begin { onunit }
         if error_flag
         then                           { do not loop on multiple errors }
         else
         begin
            error_flag := true;
            main_state := command_error;
            screen_message('Attempting to recover from paging file error.',
                           true);
            screen_message('Use DELBUF to delete some buffers if possible.',
                           true);
            with the_entry do           { get another block from heap instead }
            begin { of paging out }
               old_block_ad := block_ad;
               new(block_ad);
               new_block_count := new_block_count + 1;
               block_ad^ := old_block_ad^;
               if file_key = top_paging_key then
               begin { error was probably disk full or max quota exceeded }
                  file_key := 0;
                  top_paging_key := top_paging_key - 1
               end { error was probably disk full or max quota exceeded }
            end { of paging out } ;
            goto 232
         end
      end { onunit } ;

   begin { page_out_block }
      error_flag := false;
      {---teststart---}
      if not mode_test then
      {---teststop---}
      on('ERROR_TRAP', onunit);
      with the_entry do
      begin
         if paged_out_copy_ok
         then                           { no need to copy out }
            {---teststart---}
            if mode_test
            then if file_key <= 0
                 then writeln('paged_out_copy_ok true but file_key <= 0')
                 else writeln('block copy still ok at key ',file_key:1)
            else
            {---teststop---}
         else
         begin
            if file_key <= 0
            then allocate_key(file_key)  { choose new file record number }
            else;                       { reuse old one }
            seek(paging_file, file_key);
            paging_file^ := block_ad^;
            put(paging_file);
            paged_out_copy_ok := true   { correct copy now on disc }
         end;
         block_ad := nil
      end;
      with the_buff
      do memory_blocks := memory_blocks - 1;
      blocks_paged_out := blocks_paged_out + 1;
   232:
   end { page_out_block } ;

   { Try to get a candidate for paging out from the given buffer }

   function try_buffer(var the_buffer: buffer_info;
                       var ptr_found: ptr_file_block): boolean;

   var
      state, inner_state: search_type;
      isub: index_range;
      index_ptr: ptr_index_block;

   begin { try_buffer }
      with the_buffer do
      if memory_blocks = 0
      then try_buffer := false          { poor buffer! }
      else
      begin
         index_ptr := first_index;
         state := searching;
         repeat
            if index_ptr = avoid_index
            then inner_state := not_found
            else with index_ptr^ do
            begin
               inner_state := searching;
               isub := top_entry;       { start with last }
               repeat
                  if entries[isub].block_ad <> nil
                  then inner_state := found
                  else if isub > 1
                  then isub := isub - 1
                  else inner_state := not_found
               until inner_state <> searching
            end;
            if inner_state = found
            then state := found
            else if index_ptr^.next = nil
                 then state := not_found
                 else index_ptr := index_ptr^.next
         until state <> searching;
         if state = found then
         with index_ptr^ do
         begin
            try_buffer := true;
            ptr_found := entries[isub].block_ad;
            page_out_block(the_buffer,entries[isub])
         end
         else try_buffer := false
      end { memory_blocks > 0 }
   end { try_buffer } ;

   { Select a suitable block for paging out }

   function select_and_page_out: ptr_file_block;

   var
      state: search_type;
      ptr_found: ptr_file_block;
      temp_ptr: ptr_buffer_info;
      done: boolean;
      buffer_cnt: buffer_range;

   begin { select_and_page_out }
      with current_buffer do            { avoid paging out blocks near to }
      begin { where user is editing }
         avoid_index := current_index
      end { where user is editing } ;
      if multiple_buffers_used then
      begin { try the non-current buffers first }
         buffer_cnt := 1;
         state := searching;
         repeat
            if target_buffer_number = buffer_max
            then target_buffer_number := 1
            else target_buffer_number := target_buffer_number + 1;
            if target_buffer_number = current_buffer_number
            then done := false          { avoid the current buffer }
            else
            begin
               temp_ptr := buffer_pointers[target_buffer_number].bptr;
               if temp_ptr = nil
               then done := false       { it is empty }
               else done := try_buffer(temp_ptr^, ptr_found)
            end;
            if done
            then state := found
            else if buffer_cnt < buffer_max
                 then buffer_cnt := buffer_cnt + 1
                 else state := not_found
         until state <> searching
      end { try the non-current buffers first }
      else state := not_found;          { BUFF n not used - pointless to try
                                          other buffers }
      if state = not_found
      then if try_buffer(current_buffer, ptr_found)
           then                         { found in current buffer }
           else abort('selectandpageout: no buffer found');
      select_and_page_out := ptr_found
   end { select_and_page_out } ;

begin { obtain_file_block }
   if free_blocks <> nil then
   begin { try list of free blocks }
      get_back_entry(free_blocks, temp_entry);
      obtain_file_block := temp_entry.block_ad
   end { try list of free blocks }
   else
   begin { try to get some memory }
      if new_block_count >= new_block_max then
      begin { extend heap if possible }
         { only try if top_paging_key is zero or mult of 64 }
         if (top_paging_key mod 64) = 0 then
         begin { give it a try }
            free_segments := free_dynamic_segments;
            if free_segments > minimum_free_segments
            then new_block_max := new_block_max + 64;
            {---teststart---}
            if mode_test
            then writeln('free_segments = ',free_segments:1,
                       '  new_block_max = ',new_block_max:1);
            {---teststop---}
         end { give it a try }
      end { extend heap if possible } ;
      if new_block_count < new_block_max then
      begin { get new one from heap }
         new(temp_entry.block_ad);
         new_block_count := new_block_count + 1;
         obtain_file_block := temp_entry.block_ad
      end { get new one from heap }
      else obtain_file_block := select_and_page_out  { last ditch - page out }
   end { try to get some memory } ;
   with the_buffer
   do memory_blocks := memory_blocks + 1
end { obtain_file_block } ;

{ Close and delete paging file and clear "file_key" entries for all indexes.
  If being closed because of quit command etc., then entries are set to -1
  to indicate that they are lost. }

procedure close_paging_file(empty: boolean);                                    { CLOSE_PAGING_FILE }

var
   bindex: buffer_range;
   temp_buffer: ptr_buffer_info;
   temp_index: ptr_index_block;
   unit, tipe, code: shortint;
   set_key: integer;

   { Clear the file_key entry of all index entries as paging file now closed }

   procedure clear_keys(var the_buffer: buffer_info);

   var
      eindex: index_range;
      index_ptr: ptr_index_block;

   begin { clear_keys }
      index_ptr := the_buffer.first_index;
      while index_ptr <> nil do
      with index_ptr^ do
      begin
         for eindex := 1 to top_entry do
         with entries[eindex] do
         begin
            if block_ad = nil           { actually paged out }
            then file_key := set_key
            else file_key := 0;
            paged_out_copy_ok := false
         end;
         index_ptr := next
      end
   end { clear_keys } ;

begin { close_paging_file }
   if empty                             { calculate key value to set }
   then set_key := 0
   else set_key := -1;
   if blocks_paged_out < 0
   then screen_message('close_paging_file: blocks_paged_out < 0', true);
   blocks_paged_out := 0;               { always clear it - it may be > 0 }
                                        { when closed at QUIT }
   top_paging_key := 0;
   close(paging_file);
   screen_message('Paging file closed.', true);
   fil$dl(paging_file_name, code);
   if code <> 0
   then error_print(k$irtn, code, 'Deleting paging file', 'FIL$DL');
   {---teststart---}
   if mode_test
   then writeln('Paging file deleted.');
   {---teststop---}
   paging_file_open := false;
   while free_keys <> nil do            { throw away saved file keys }
   begin
      temp_index := free_keys^.next;
      dispose(free_keys);
      index_block_count := index_block_count - 1;
      free_keys := temp_index
   end;
   for bindex := 1 to buffer_max do
   begin
      if bindex = current_buffer_number
      then clear_keys(current_buffer)
      else
      begin
         temp_buffer := buffer_pointers[bindex].bptr;
         if temp_buffer <> nil
         then clear_keys(temp_buffer^)
      end { not current buffer }
   end { for loop }
end { close_paging_file } ;

{ Page in a specified block }

procedure page_in_any_block(var the_buffer: buffer_info;                        { PAGE_IN_ANY_BLOCK }
                            var the_entry: index_entry);

   { replace lost text of block by blank lines }

   procedure set_block_blank;

   var
      bindex: data_words_range;
      fiddle: record
         case boolean of
            false:(chs: packed array[1..2] of char);
            true: (wds: shortint)
         end;

   begin { set_block_blank }
      with the_buffer, the_entry, block_ad^ do
      begin
         message := 'Lines ~ to ~ lost.';
         ins_int(lines_above+1          , 1);
         ins_int(lines_above+block_lines, 1);
         screen_message(message, true);
         fiddle.wds := 0;
         fiddle.chs[1] := newline;      { newline/null }
         for bindex := 1 to block_lines
         do data_words[bindex] := fiddle.wds;
         split_start := block_lines + 1;
         split_end := block_max_wordsp1;
         paged_out_copy_ok := false
      end { with }
   end { set_block_blank } ;

   procedure get_the_block;

   label 223;

   var
      error_flag: boolean;

      procedure error_trap_onunit(not_used: integer);

      begin { error_trap_onunit }
         if error_flag
         then                           { do not loop on multiple errors }
         else
         begin
            comm_error('Failed to page in block from paging file.');
            error_flag := true;
            set_block_blank;
            goto 223
         end
      end { error_trap_onunit } ;

   begin { get_the_block }
      with the_entry do
      begin
         error_flag := false;
         on('ERROR_TRAP', error_trap_onunit);
         seek(paging_file, file_key);
         get(paging_file);
         { copy in correct contents from file }
         block_ad^ := paging_file^
      end { with } ;
   223:                                 { re-enter here if paging file error }
      blocks_paged_out := blocks_paged_out - 1;
      if blocks_paged_out <= 0
      then close_paging_file(true)      { it is now empty }
   end { get_the_block } ;

begin { page_in_any_block }
   with the_buffer, the_entry do
   begin { need to copy it in }
      block_ad := obtain_file_block(the_buffer);  { get memory block }
      if file_key < 0 then
      begin { file block lost because paging file was closed }
         screen_message('Paged-out block lost because paging file was closed.',
                        true);
         set_block_blank
      end { block lost }
      else get_the_block
   end { with }
end { page_in_any_block } ;

{ Page in the current block if offline }

procedure page_in_block;                                                        { PAGE_IN_BLOCK }

begin { page_in_block }
   with current_buffer, current_index^
   do if entries[index_sub].block_ad = nil
      then page_in_any_block(current_buffer, entries[index_sub])
end { page_in_block } ;

{ Page in the current load buffer block }

procedure page_in_load_block;                                                   { PAGE_IN_LOAD_BLOCK }

begin { page_in_load_block }
   with load_file, buffer_pointers[load_buffer_number].bptr^, load_index^
   do if entries[load_index_sub].block_ad = nil
      then page_in_any_block(buffer_pointers[load_buffer_number].bptr^,
                             entries[load_index_sub])
end { page_in_load_block } ;

{ Count the lines in the part of a file block indicated by word
  subscripts 'start' and 'stop'. Set 'lastnl' to word subscript of last
  newline found. }

   function cntlines(var area: data_words_type;
                     start: data_words_range;
                     stop: data_words0_range;
                     var lastnl: data_words0_range): integer;

      extern;                           { now written in PMA for speed }

{ Copy part of a block out to another buffer }

procedure copy_to_buffer(var from_data_words: data_words_type;                  { COPY_TO_BUFFER }
                         fromsub1: data_words_range;
                         fromsub2: data_words0_range);

var
   from_words, split_size, added_lines: integer;
   temp_index: ptr_index_block;
   lastnl: data_words0_range;

begin { copy_to_buffer }
   from_words := fromsub2 - fromsub1 + 1;
   page_in_load_block;
   with load_file, load_index^, entries[load_index_sub], block_ad^ do
   begin
      split_size := split_end - split_start;
      if from_words <= split_size then
      begin { there is space }
         movewds(from_data_words, fromsub1, data_words, split_start,
                 from_words);
         added_lines := cntlines(from_data_words, fromsub1, fromsub2, lastnl);
         block_lines := block_lines + added_lines;
         split_start := split_start + from_words;
         paged_out_copy_ok := false     { block has been altered }
         {---teststart---}
         ;if mode_test
         then writeln('copy_to_buffer: added_lines = ',added_lines:1)
         {---teststop---}
      end { there is space }
      else
      begin { insufficient space in block }
         if load_index_sub < index_max then
         begin { space in index block }
            top_entry := top_entry + 1;
            load_index_sub := load_index_sub + 1
         end { space in index block }
         else
         begin { creat new index block }
            new(temp_index);
            index_block_count := index_block_count + 1;
            next := temp_index;
            with temp_index^ do
            begin
               next := nil;
               previous := load_index;
               load_index := temp_index;
               top_entry := 1;
               load_index_sub := 1
            end
         end { creat new index block } ;
         with buffer_pointers[load_buffer_number].bptr^, load_index^,
              entries[load_index_sub] do
         begin
            blocks := blocks + 1;
            block_lines := 0;
            block_ad := nil;            { ensure that this block is not chosen }
                                        { for paging out before it is set up }
                                        { as it is not protected by being in }
                                        { the current buffer }
            block_ad :=
               obtain_file_block(buffer_pointers[load_buffer_number].bptr^);
            split_start := 1;
            split_end := block_max_wordsp1;
            file_key := 0;
            paged_out_copy_ok := false
         end;
         copy_to_buffer(from_data_words, fromsub1, fromsub2)
      end { insufficient space in block }
   end { with }
end { copy_to_buffer } ;

{ Copy one or more blocks from buffer to fill split in current block }

procedure copy_from_buffer(var last_line_read: integer);                        { COPY_FROM_BUFFER }

var
   done: boolean;
   split_words, block_words, added_lines: integer;
   load_entry: index_entry;
   lastnl: data_words0_range;

begin { copy_from_buffer }
   with current_buffer, current_index^, entries[index_sub], block_ad^,
        load_file do
   begin
      added_lines := 0;
      done := false;
      repeat
         page_in_load_block;
         split_words := split_end - split_start;
         with load_index^ do
         begin
            load_entry := entries[load_index_sub];
            block_words := load_entry.split_start - 1;
            if block_words <= split_words then
            begin { it fits }
               movewds(load_entry.block_ad^.data_words, 1,
                       data_words, split_start,
                       block_words);
               block_lines := block_lines + load_entry.block_lines;
               added_lines := added_lines + load_entry.block_lines;
               split_start := split_start + block_words;
               if load_index_sub < top_entry
               then load_index_sub := load_index_sub +1
               else if next = nil then
               begin { end of buffer }
                  file_is_open := false;
                  done := true
               end { end of buffer }
               else
               begin { on to next index block }
                  load_index := next;
                  load_index_sub := 1
               end { on to next index block }
            end { it fits }
            else done := true           { will not fit }
         end { with load_index^ }
      until done;
      last_line_read := cntlines(data_words, 1, split_start - 1, lastnl);
      {---teststart---}
      if mode_test
      then writeln('copy_from_buffer: added_lines = ',added_lines:1)
      {---teststop---}
   end { with }
end { copy_from_buffer } ;

{ Save the block address and/or the paging file key of an index entry. }
{ Assumes the entry is somewhere in the current buffer. }

procedure save_entry_contents(the_entry: index_entry);                          { SAVE_ENTRY_CONTENTS }

   { Save an index entry for the sake of either its memory block address or its
     paging file record number }

   procedure save_entry(var top_point: ptr_index_block;
                        the_entry: index_entry);

      { create a new index block }
      procedure get_new_entry;
      var
         temp_ptr: ptr_index_block;
      begin { get_new_entry }
         new(temp_ptr);
         index_block_count := index_block_count + 1;  { do not test and warn }
         with temp_ptr^ do
         begin
            next := top_point;
            top_point := temp_ptr;
            top_entry := 0
         end
      end { get_new_entry } ;

   begin { save_entry }
      if top_point = nil
      then get_new_entry                { no entries yet }
      else if top_point^.top_entry = index_max
      then get_new_entry;               { top block is full }
      with top_point^ do
      begin
         top_entry := top_entry + 1;
         entries[top_entry] := the_entry
      end
   end { save_entry } ;

begin { save_entry_contents }
   with current_buffer, the_entry do
   begin
      { Save file_key part of entry, but only if paging file open. }
      { May try to save even after paging file closed (which clears out }
      { all paging keys) because a copy of an entry may be involved. }
      if (file_key > 0) and paging_file_open then
      begin
         {---teststart---}
         if mode_test
         then writeln('Saving file key ',file_key:1);
         {---teststop---}
         save_entry(free_keys, the_entry)
      end;
      if block_ad = nil then
      begin { block was paged out }
         blocks_paged_out := blocks_paged_out - 1;
         if blocks_paged_out <= 0
         then close_paging_file(true)
      end { block was paged out }
      else
      begin { block was in memory }
         if new_block_count > new_block_max then
         begin { can happen if paging error occurred }
            dispose(block_ad);
            new_block_count := new_block_count - 1
         end { can happen if paging error occurred }
         else save_entry(free_blocks, the_entry);  { save the memory block }
         memory_blocks := memory_blocks - 1  { one less in the buffer }
      end { block was in memory }
   end { with }
end { save_entry_contents } ;

{ Look in the given block for the next word containing a newline, updating }
{ word_index to point to it. }

procedure find_next_newline(var word_index: data_words0p1_range;                { FIND_NEXT_NEWLINE }
                            start_of_area: data_words_range;
                            backwards: boolean);


type
   word_split_type = record             { a word or two characters }
      case boolean of
         true:  (word: shortint);
         false: (chars: packed array[1..2] of char)
      end;

var
   word_split: word_split_type;
   found, done: boolean;
   increment: -1..1;
   windex: data_words_range;
   dc1_count, last_to_test, chindex: integer;
   state: (not_found, at_left, at_right);

begin { find_next_newline }
   with current_buffer, current_index^, entries[index_sub], block_ad^,
        word_split do
   begin
      if backwards
      then increment := -1
      else increment := 1;
      windex := word_index;             { use local range for speed }
      found := false;
      repeat
         word := data_words[windex];
         if chars[2] = newline
         then state := at_right
         else if chars[1] = newline
         then state := at_left
         else state := not_found;
         { We have found a newline but it may be merely the space suppression }
         { count following a DC1; we need to look backwards counting DC1s. }
         { An odd number of DC1s means the newline is just  a count.}
         { An even number (usually zero!) means it is pukka. }
         if state <> not_found then
         begin { test for DC1s }
            dc1_count := 0;
            chindex := (windex - 1) * 2;
            if state = at_right
            then chindex := chindex + 1;
            last_to_test := start_of_area*2 - 1;
            done := false;
            repeat
               if chindex < last_to_test
               then done := true
               else if data_chars[chindex] = chr(dc1_code) then
               begin { dc1 found }
                  dc1_count := dc1_count + 1;
                  chindex := chindex - 1
               end { dc1 found }
               else done := true
            until done;
            if odd(dc1_count)
            then { ignore this newline }
            else found := true
         end { test for DC1s } ;
         if not found
         then windex := windex + increment
      until found;
      word_index := windex
   end { with }
end { find_next_newline } ;

   procedure close_file(var pfile: primos_file); forward;

{ Read some text from a primos file into part of the current block }

procedure read_a_block(var pfile: primos_file;                                  { READ_A_BLOCK }
                       var last_line_read: integer);

var
   rnw, code: shortint;
   new_split_start, corrected_split_start, words_full, toread,
   added_lines: integer;
   lastnl, ignore: data_words0_range;

   { add newline to end of text }

   procedure add_newline_at_end;

   begin { add_newline_at_end }
      {---teststart---}
      if mode_test
      then writeln('read_a_block: add_newline_at_end');
      {---teststop---}
      { add a word newline/newline because the last actual character of the }
      { block could be a DC1 for space suppression; in that case the first }
      { newline is treated as the count character }
      with current_buffer, current_index^, entries[index_sub], block_ad^
      do data_words[new_split_start] := double_newline;
      new_split_start := new_split_start + 1
   end { add_newline_at_end } ;

begin { read_a_block }
   with current_buffer, current_index^, entries[index_sub], block_ad^ do
   begin
      words_full := block_max_words - (split_end - split_start);
      { Empty blocks are only filled up to tide mark }
      { Part full ones must allow space for newline to be added if absent }
      if words_full = 0
      then toread := block_tide_words
      else toread := block_max_words - words_full - 1;
      if toread > 0 then
      with pfile do
      begin { space available for reading }
         prwf$$(k$read, unit, addressof( data_words[split_start] ),
                toread, prepos, rnw, code);
         new_split_start := split_start + rnw;
         if code = e$eof then
         begin { end of file reached }
            close_file(pfile);
            code := 0;                  { do not treat eof as error }
            {---teststart---}
            if mode_test
            then writeln('read_a_block: file closed');
            {---teststop---}
            if rnw > 0                  { some words actually read }
            then
               if (data_chars[new_split_start*2 - 3] <> newline ) and
                  (data_chars[new_split_start*2 - 2] <> newline )
               then add_newline_at_end  { no newline at end of file }
         end { end of file reached } ;
         if code <> 0 then
         begin
            error_print(k$irtn, code, concat('Reading ',treename.strng),
                        'PRWF$$');
            close_file(pfile);
            file_truncated := true;
            comm_error('The workfile has been truncated at this point because of a file system error.');
            new_split_start := split_start;  { no lines read }
            rnw := 1                    { force adding of newline below }
         end;
         added_lines :=
            cntlines(data_words, split_start, new_split_start-1, lastnl);
         if (added_lines = 0) and (words_full = 0) and (rnw > 0) then
         begin { no newlines in whole block }
            lastnl := new_split_start;
            add_newline_at_end;
            added_lines := 1
         end { no newlines in whole block } ;
         { compute the relative line number of the last line read in }
         last_line_read := added_lines +
            cntlines(data_words, 1, split_start - 1, ignore);
         corrected_split_start := lastnl + 1;
         { the part of the block after the last newline will be read again }
         { by the next call to prwf$$ - prepos is the number of words }
         prepos := -( rnw - (corrected_split_start - split_start) );
         if prepos > 0                  { happens when we add a newline to the }
         then prepos := 0;              { end of a block containing none }
         block_lines := block_lines + added_lines;
         split_start := corrected_split_start
         {---teststart---}
         ;if mode_test
         then writeln('read_a_block: added_lines = ',added_lines:1)
         {---teststop---}
      end { space available for reading }
      else last_line_read := 0
   end { with }
end { read_a_block } ;

{ Set up a new empty block at current index position }

procedure setup_empty_block;                                                    { SETUP_EMPTY_BLOCK }

begin { setup_empty_block }
   with current_buffer, current_index^, entries[index_sub] do
   begin
      block_lines := 0;                 { no lines in block yet }
      block_ad := obtain_file_block(current_buffer);
      split_start := 1;                 { split goes from word 1 }
      split_end := block_max_wordsp1;   { to top of block }
      file_key := 0;                    { no place allocated in paging file }
      paged_out_copy_ok := false
   end { with }
end { setup_empty_block } ;

{ Close the split in the current block }

procedure close_split;                                                          { CLOSE_SPLIT }

begin { close_split }
   with current_buffer, current_index^, entries[index_sub], block_ad^ do
   begin
      movewds(data_words, split_end,
              data_words, split_start,
              block_max_words - split_end + 1);
      split_start := split_start + block_max_wordsp1 - split_end;
      split_end := block_max_wordsp1
   end { with }
end { close_split } ;

{ Move the split in the current block to after the current line }

procedure move_split;                                                           { MOVE_SPLIT }

var
   moved: data_words0_range;

begin { move_split }
   with current_buffer, current_index^, entries[index_sub], block_ad^ do
   begin
      paged_out_copy_ok := false;
      moved := split_end - split_start;
      if (line_end + 1) < split_start then
      begin { line is below the split }
         movewds(data_words, line_end + 1,
                 data_words, line_end + 1 + split_end - split_start,
                 split_start - line_end - 1);
         split_end := line_end + 1 + moved;
         split_start := line_end + 1
      end { line is below the split }
      else if (line_end + 1) > split_start then
      begin { line is above the split }
         movewds(data_words, split_end,
                 data_words, split_start,
                 line_end - split_end + 1);
         split_end := line_end + 1;
         line_start := line_start - moved;
         line_end := line_end - moved;
         split_start := line_end + 1
      end { line is above the split }
   end { with }
end { move_split } ;

{ Delete the current block if it is empty, but leave at least one block  }
{ in the index. The memory block and file key (if present) are saved for }
{ reuse later.                                                           }

function delete_if_empty: boolean;                                              { DELETE_IF_EMPTY }

var
   bindex: 1..index_max;
   saved_entry: index_entry;

begin { delete_if_empty }
   with current_buffer, current_index^, entries[index_sub] do
   if (block_lines = 0) and (blocks > 1) then
   begin { it is empty }
      save_entry_contents(entries[index_sub]);
      top_entry := top_entry - 1;       { compact the index block }
      blocks := blocks - 1;
      for bindex := index_sub to top_entry
      do entries[bindex] := entries[bindex + 1];
      delete_if_empty := true
   end { it is empty }
   else delete_if_empty := false
end { delete_if_empty } ;

{ Delete the empty current index block.  Leaves "current_index" unset. }

procedure delete_index_block;                                                   { DELETE_INDEX_BLOCK }

begin { delete_index_block }
   with current_buffer, current_index^ do
   begin
      if previous = nil
      then first_index := next
      else previous^.next := next;
      if next = nil
      then
      else next^.previous := previous;
      dispose(current_index);
      index_block_count := index_block_count - 1
   end { with }
end { delete_index_block } ;

{ Insert a new empty index block after the current }

procedure get_new_index_block;                                                  { GET_NEW_INDEX_BLOCK }

var
   temp_ptr, next_ptr: ptr_index_block;

begin { get_new_index_block }
   new(temp_ptr);                       { create new index block }
   index_block_count := index_block_count + 1;
   with current_buffer do
   begin
      next_ptr := current_index^.next;  { this one is after current }
      temp_ptr^.next := next_ptr;       { temp -> next }
      current_index^.next := temp_ptr;  { current -> temp }
      temp_ptr^.previous := current_index;  { temp -> current }
      if next_ptr <> nil
      then next_ptr^.previous := temp_ptr;  { next -> temp }
      temp_ptr^.top_entry := 0          { temp is empty }
   end { with }
end { get_new_index_block } ;

{ Move back to previous file block in index }

function get_previous_block: boolean;                                           { GET_PREVIOUS_BLOCK }

var
   result: boolean;
   temp_ptr: ptr_index_block;

begin { get_previous_block }
   with current_buffer, current_index^ do
   if block_number = 1
   then get_previous_block := false     { at .top. }
   else
   begin { not first block }
      result := delete_if_empty;
      if index_sub = 1
      then if previous = nil
           then abort('get_previous_block: previous = nil')
           else
           begin
              temp_ptr := previous;
              if top_entry = 0          { delete whole index block if empty }
              then delete_index_block;
              current_index := temp_ptr;
              index_sub := temp_ptr^.top_entry
           end
      else index_sub := index_sub - 1;
      get_previous_block := true;
      with current_buffer, current_index^, entries[index_sub] do
      begin { new with in case current_index changed }
         last_line_in_block := lines_above;
         lines_above := lines_above - block_lines;
         block_number := block_number - 1
      end { with }
   end { not block 1 }
end { get_previous_block } ;

{ Move on to next file block in index.  Only tests for user hitting BREAK in }
{ the situation where it has to read in a file block. }

function get_next_block(var user_quit: boolean): boolean;                       { GET_NEXT_BLOCK }

var
   last_line_read, lines_to_add: integer;
   done, result: boolean;
   temp_ptr: ptr_index_block;

   { move on one index entry, creating new entry if necessary }

   procedure move_on_one;

   begin { move_on_one }
      with current_buffer, current_index^ do
      begin
         if index_sub < top_entry
         then index_sub := index_sub + 1  { still within block }
         else if next <> nil then
         begin { next exists }
            current_index := next;
            index_sub := 1
         end { next exists }
         else
         begin { create new index entry at .bottom. }
            if top_entry < index_max then
            begin { still space in index block }
               top_entry := top_entry + 1;
               index_sub := top_entry
            end { still space in index block }
            else
            begin { need new index block }
               get_new_index_block;
               current_index := next;
               current_index^.top_entry := 1;
               index_sub := 1
            end { need new index block } ;
            setup_empty_block
         end { create new index entry at .bottom. } ;
         block_number := block_number + 1;
         done := true
      end { with }
   end { move_on_one } ;

begin { get_next_block }
   with current_buffer do
   begin
      user_quit := false;               { returned as true if breakin or error }
                                        { when reading file block i.e. a time }
                                        { consuming operation }
      done := false;
      with current_index^, entries[index_sub] do
      if block_lines = 0 then
      begin { delete file block if empty }
         if block_number = 1 then
         begin { first block in file }
            if top_entry > 1 then
            begin { >1 entries in block }
               result := delete_if_empty;
               done := true
            end { >1 entries in block }
            else if next = nil
            then { cannot delete - only 1 block in file }
            else
            begin { delete single entry in block }
               result := delete_if_empty;
               done := true;
               temp_ptr := next;
               delete_index_block;
               current_index := temp_ptr
            end { delete single entry in block }
         end { first block in file }
         else if not get_previous_block  { just do it the easy way }
              then abort('get_next_block: get_previous_block failed')
      end { delete file block if empty } ;

      with current_index^ do
      begin
         if done
         then lines_to_add := 0         { block was empty }
         else
         begin { block not empty }
            lines_to_add := entries[index_sub].block_lines;
            if index_sub < top_entry
            then move_on_one
            else if next = nil
            then if main_file.file_is_open then
                 begin
                    move_on_one;
                    blocks := blocks + 1;
                    read_a_block(main_file, last_line_read);
                    user_quit := main_state <> running
                 end
                 else                   { at .bottom. }
            else move_on_one
         end { block not empty }
      end { with } ;

      { set details of new block }

      if done
      then lines_above := lines_above + lines_to_add;
      { do next part even if "done" is false because of awkward cases such }
      { as reading zero words into last block at eof }
      with current_index^.entries[index_sub] do
      begin
         last_line_in_block := lines_above + block_lines
      end;
      get_next_block := done
   end { with }
end { get_next_block } ;

{ Find the file block which contains a given line number and set it
  up as the current block }

procedure find_block(number: integer;                                           { FIND_BLOCK }
                     var at_bottom: boolean);

var
   state: search_type;
   user_quit: boolean;

begin { find_block }
   with current_buffer, current_index^ do
   begin
      close_split;                      { close the split (if any) }
      if number <= 0 then
      begin { go to .top. quickly }
         current_index := first_index;
         index_sub := 1;
         block_number := 1;
         lines_above := 0;
         with current_index^, entries[1] do
         begin
            last_line_in_block := block_lines
         end;
         at_bottom := false
      end { go to .top. quickly }
      else if number <= lines_above then
      begin { required block is above current }
         repeat
            if get_previous_block
            then                        { moved up OK }
            else abort('find_block: get_previous_block failed')
         until number > lines_above;
         at_bottom := false
      end { required block is above current }
      else
      begin { required block is below current }
         last_line_in_block := lines_above + entries[index_sub].block_lines;
         state := searching;
         repeat
            if number <= last_line_in_block
            then state := found
            else if get_next_block(user_quit)
            then if user_quit           { still searching }
                 then state := found    { dropout on quit or error }
                 else
            else state := not_found     { no more blocks }
         until state <> searching;
         at_bottom := state = not_found
      end { required block is below current }
   end { with } ;
   page_in_block                        { ensure block is in memory }
end { find_block } ;

{ Expand the split in the current block to be >= length_requested }

procedure expand_split(length_requested: integer);                              { EXPAND_SPLIT }

var
   start: integer;
   lastnl: data_words0_range;
   new_block_address: ptr_file_block;
   user_quit: boolean;

   { Insert new empty block after current; does not affect current. }
   { Leaves new_block_address set pointing to new block. }

   procedure insert_new_block;

   var
      iindex: 1..index_max;

   begin { insert_new_block }
      with current_buffer, current_index^ do
      begin

         { first ensure there is at least one empty slot in the index block }

         if top_entry = index_max then
         begin { block is full }
            { ensure >= 1 free entries in next index block }
            if next = nil
            then get_new_index_block
            else if next^.top_entry = index_max
            then get_new_index_block;
            with next^ do
            begin { move all up one place }
               for iindex := top_entry downto 1
               do entries[iindex + 1] := entries[iindex];
               top_entry := top_entry + 1
            end { move all up one place } ;
            next^.entries[1] := entries[index_max];
            top_entry := top_entry - 1
         end { block is full } ;

         if index_sub = index_max then
         begin { the one moved out was the current index entry! }
            current_index := next;
            index_sub := 1;
            insert_new_block            { try again }
         end { the one moved out was the current index entry! }
         else
         begin { move entries up and insert new one }
            for iindex := top_entry downto (index_sub + 1)
            do entries[iindex + 1] := entries[iindex];
            with entries[index_sub + 1] do
            begin
               block_lines := 0;
               block_ad := obtain_file_block(current_buffer);
               new_block_address := block_ad;
               file_key := 0;
               paged_out_copy_ok := false
            end { with } ;
            top_entry := top_entry + 1;  { one more entry in index block }
            blocks := blocks + 1        { and file }
         end { move entries up and insert new one }
      end { with }
   end { insert_new_block } ;

begin { expand_split }
   with current_buffer do
   begin
      {---teststart---}
      if mode_test
      then writeln('expand_split: (begin) index_sub = ',index_sub:1);
      {---teststop---}

      { First shift part above split (if any) into a new block }

      with current_index^, entries[index_sub], block_ad^ do
      if split_end <= block_max_words then
      begin { block is split }
         insert_new_block;
         { new with because index_sub may have changed }
         with current_index^, entries[index_sub], block_ad^ do
         begin
            start := split_end;
            movewds(data_words, start,
                    new_block_address^.data_words, 1,
                    block_max_words - start + 1);
            { tidy up old block (essential before calling get_next_block) }
            split_end := block_max_wordsp1;  { not split }
            { set block_lines to 1 temporarily because if the true value is }
            { zero, then the call to get_next_block below will delete this one }
            block_lines := 1;
            paged_out_copy_ok := false
         end { with } ;
         { tidy up new block }
         if not get_next_block(user_quit)
         then abort('expand_split: get_next_block failed');
         with current_index^, entries[index_sub], block_ad^ do
         begin { new with }
            split_start := block_max_words - start + 2;
            split_end := block_max_wordsp1;  { not split }
            block_lines := cntlines(data_words, 1, split_start-1, lastnl);
            { paged_out_copy_ok cleared in insert_new_block }
         end { new with } ;
         if not get_previous_block
         then abort('expand_split: get_previous_block failed');
         { now set correct value for "block_lines" in old block }
         with current_index^, entries[index_sub], block_ad^
         do block_lines := cntlines(data_words, 1, split_start-1, lastnl)
      end { block is split } ;

      { If there is still not enough room, try for space in next block }

      with current_index^, entries[index_sub] do
      if ((block_max_words+1 - split_start) < length_requested)
         and (block_number < blocks) then  { next block exists }
      begin { try next block }
         if not get_next_block(user_quit)
         then abort('expand_split: get_next_block failed');
         page_in_block;
         with current_index^, entries[index_sub] do
         begin
            if (block_max_wordsp1 - split_start) >= length_requested then
            begin { found enough room }
               line_end := 0;
               move_split
            end { found enough room }
            else
            begin { not enough room }
               if not get_previous_block  { back again }
               then abort('expand_split: get_previous_block failed');
               page_in_block
            end { not enough room }
         end { with }
      end { try next block } ;

      { If still not enough room then overflow into a new block }

      with current_index^, entries[index_sub] do
      if (block_max_words+1 - split_start ) < length_requested then
      begin { not enough room }
         insert_new_block;
         if not get_next_block(user_quit)
         then abort('expand_split: get_next_block failed');
         with current_index^, entries[index_sub] do
         begin
            split_start := 1;
            split_end := block_max_wordsp1
         end { with }
      end { not enough room } ;
      {---teststart---}
      if mode_test
      then writeln('expand_split: (end)   index_sub = ',index_sub:1);
      {---teststop---}
   end { with }
end { expand_split } ;

{ Copy the current line into the split in the current block }

procedure copy_out_line;                                                        { COPY_OUT_LINE }

var
   compressed_line: line_words_type;    { current file line after space }
                                        { compression }
   comp_length: line_words_range;       { length in words }

   { local dcl for movewds just to use different type for from_string }

   procedure movewds(from_string: line_words_type;
                     fromsub: integer;
                     var to_string: data_words_type;
                     tosub: integer;
                     wd_count: integer);
      extern;                           { written in PMA }

   { Compress spaces in current line and return length in words }

   function compress(line_text: line_chars_type;
                     line_length: line_chars0_range;
                     var compressed_line: line_words_type;
                     line_max_chars: integer;
                     var comp_length: line_words_range): boolean;
      extern;                           { written in PMA }

begin { copy_out_line }
   with current_buffer, current_index^, entries[index_sub] do
   begin
      file_altered := true;             { file has now been changed }
      if not compress(line_text, line_length, compressed_line, line_max_chars,
                      comp_length)
      then abort('compress failed');
      move_split;                       { ensure split below current line }
      split_start := line_start;        { remove old version of line }

      { If the split in the current block is not long enough then }
      { expand it - this may change the current block }

      if (split_end - split_start) < comp_length then
      begin { not enough space in current block }
         { update in case index_sub changed }
         with current_index^.entries[index_sub]
         do block_lines := block_lines -1;  { one line removed from block }
         expand_split(comp_length);
         with current_index^.entries[index_sub]
         do block_lines := block_lines + 1  { one line replaced in block }
      end { not enough space in current block } ;

      { new with because current block may have changed }
      with current_index^, entries[index_sub], block_ad^ do
      begin
         {---teststart---}
         if mode_test
         then writeln('copy_out_line: split_start = ',split_start:1,
                      ' split_end = ',split_end:1,
                      ' comp_length = ',comp_length:1);
         {---teststop---}
         movewds(compressed_line, 1, data_words, split_start, comp_length);
         line_start := split_start;     { new line position in block }
         line_end := split_start + comp_length - 1;
         split_start := line_end + 1;
         {---teststart---}
         if mode_test
         then writeln('copy_out_line: split_start = ',split_start:1,
                      ' split_end = ',split_end:1)
         {---teststop---}
      end { with }
   end { with }
end { copy_out_line } ;

   procedure split_long_line; forward;

{ Copy a line from workfile into current line buffer, expanding spaces }

procedure copy_in_line;                                                         { COPY_IN_LINE }

var
   overflow: boolean;

   function uncomp(block: data_words_type;
                   line_start, line_end: data_words0p1_range;
                   var line_text: line_chars_type;
                   line_max_chars: integer;
                   var line_length: line_chars0_range;
                   var overflow: boolean): boolean;
      extern;                           { written in PMA }

begin { copy_in_line }
   with current_buffer, current_index^, entries[index_sub], block_ad^ do
   begin
      if not uncomp(data_words, line_start, line_end,
                    line_text, line_max_chars, line_length, overflow)
      then abort('uncomp failed');
      if overflow then
      begin
         message := 'Line number ~ in file is longer than maximum (~) and has been split up.';
         ins_int(line_number, 1);
         ins_int(line_max_charsm1, 1);
         screen_message(message, true);
         split_long_line
      end;
      if line_length > test_line_size   { test length against LINESZ value }
      then if in_window_code
           then                         { do not overwrite screen }
           else writeln('Long line in file - line ',line_number:1,' is ',
                        line_length:1,' characters long.');
      line_altered := false;
      line_exists := true
   end { with }
end { copy_in_line } ;

%page
{******************************************}
{ HIGHER LEVEL EDITOR FILE SYSTEM ROUTINES }
{******************************************}

{ Set top of file as current 'line' }

procedure set_to_top_of_file;                                                   { SET_TO_TOP_OF_FILE }

var
   at_bottom: boolean;

begin { set_to_top_of_file }
   with current_buffer do
   begin
      find_block(0, at_bottom);
      line_exists := false;
      line_altered := false;
      line_start := 1;                  { no actual space in file }
      line_end := 0;
      line_number := 1;
      line_length := 0;
      line_position := 1;
      line_status := top
   end
end { set_to_top_of_file } ;

{ Copy current line back into the file if necessary }

procedure replace_line;                                                         { REPLACE_LINE }

begin { replace_line }
   with current_buffer, current_index^, entries[index_sub] do
   begin
      if line_exists then
      begin { line exists }
          if line_altered then
          begin { file copy is not up to date }
             copy_out_line;
             line_altered := false      { copy now ok }
          end { file copy is not up to date }
          else { no need to copy }
      end { line exists }
      else if line_start <= line_end then
      begin { there is a copy in file block }
         if line_start = split_end then
         begin { deleted line is first after split }
            split_end := line_end + 1;  { delete old copy of line }
            line_start := split_start
         end { deleted line is first after split }
         else
         begin { not first after split }
            move_split;                 { move split to below line }
            split_start := line_start;  { delete old copy of line }
         end { not first after split } ;
         line_end := line_start-1       { zero length in file }
      end { there is a copy in file block }
      else { no copy in file - top or bottom }
   end { with }
end { replace_line } ;

{ Set up a given line number as the current line }

procedure load_a_line(new_number: integer;                                      { LOAD_A_LINE }
                      print: boolean);

var
   at_bottom: boolean;
   lineno: integer;

   { find the previous line (i.e. the one before "line_start").              }
   { assumes it exists (i.e. need to test specially for first line in block) }

   procedure load_previous;

   var
      stopat: data_words_range;

   begin { load_previous }
      with current_buffer, current_index^, entries[index_sub] do
      begin
         if line_start = split_end      { allow for split in block }
         then line_end := split_start - 1
         else line_end := line_start - 1;
         line_start := line_end - 1;
         if line_start >= split_end     { if above split }
         then stopat := split_end       { then stop at top of split }
         else stopat := 1;              { else stop at beginning of block }
         find_next_newline(line_start, stopat, true);

         { if the found line is the first one above the split then the }
         { line_start position will be wrong (there is no valid newline }
         { before it ) }

         if (line_end >= split_end) and  { line is above split }
            (line_start < split_end)    { found newline in or below split }
         then line_start := split_end   { line is first after split }
         else line_start := line_start +1  { start is 1 after previous newline }
      end { with }
   end { load_previous } ;

   { find the current line in the block - the one starting at "line_start" }

   procedure load_current;

   begin { load_current }
      with current_buffer, current_index^, entries[index_sub] do
      begin
         if line_start = split_start    { allow for split in block }
         then line_start := split_end;
         if line_start > line_end then  { not set up yet - maybe after delete }
         begin
            line_end := line_start;
            find_next_newline(line_end, line_start, false)
         end
         else { line_end is already set up }
      end { with }
   end { load_current } ;

   { Find the start and end of a line in the current block. }
   { Sets 'line_start' and 'line_end'. }

   procedure find_line_place(new_number: integer);

   var
      lineno: integer;

   begin { find_line_place }
      with current_buffer do
      begin
         line_end := 0;
         for lineno := (lines_above + 1) to new_number do
         begin
            line_start := line_end + 1;
            line_end := line_start;
            find_next_newline(line_end, line_start, false)
         end { for loop }
      end { with }
   end { find_line_place } ;

begin { load_a_line }
   replace_line;                        { put current line back into file }
   if new_number < 1 then
   begin { top of file }
      set_to_top_of_file;
      if print
      then screen_message('.top.', true)
   end { top of file }
   else
   with current_buffer, current_index^, entries[index_sub] do
   begin { not top of file }
      line_position := 1;
      if (new_number > lines_above) and
         (new_number <= lines_above + entries[index_sub].block_lines)
      then
      begin { line is within current block }

         { test for various positions in current block }

         if new_number = lines_above + 1 then
         begin { first line in block }
            if split_start = 1
            then line_start := split_end
            else line_start := 1;
            line_end := line_start;
            find_next_newline(line_end, line_start, false)
         end { first line in block }
         else if new_number < line_number then
         begin { not first, but before current }
            for lineno := 1 to (line_number - new_number)
            do load_previous
         end { not first, but before current }
         else
         begin { current or later in block }
            load_current;
            for lineno := 1 to (new_number - line_number) do
            begin
               line_start := line_end + 1;
               load_current
            end { for loop }
         end { current or later in block } ;

         line_exists := true;           { set up the details of the line found }
         line_number := new_number;
         line_status := normal;
         copy_in_line
      end { line is within current block }
      else
      begin { not within current block }
         find_block(new_number, at_bottom);
         with current_index^, entries[index_sub] do
         begin
            if at_bottom then
            begin { bottom of file }
               line_exists := false;
               line_start := split_start;  { no copy in file }
               line_end := split_start - 1;
               line_number := last_line_in_block + 1;
               line_length := 0;
               line_status := bottom;
               if print
               then screen_message('.bottom.', true)
            end { bottom of file }
            else
            begin { normal line in file }
               { if error/user quit and target line not in block go to last }
               { line in block }
               if main_state <> running
               then if last_line_in_block < new_number
                    then new_number := last_line_in_block
                    else { no need - already far enough down } ;
               find_line_place(new_number);
               line_exists := true;
               line_number := new_number;
               line_status := normal;
               copy_in_line             { copy line into buffer }
            end { normal line in file }
         end { new with }
      end { not within current block }
   end { not top of file, with }
end { load_a_line } ;

{ Locate a string in the file blocks.                              }
{ The string must not contain any of the editor special chars such }
{ as blanks and wild, and must not include runs of more then one   }
{ space because of space packing in the file.                      }

procedure quick_locate(var string: line_chars_type;                             { QUICK_LOCATE }
                       var low_string: line_chars_type;
                       sstart, sstop: line_chars_range;
                       backwards: boolean;
                       case_signif: boolean;
                       print_top_or_bottom: boolean;
                       stop_line: integer);

var
   fcp: data_chars_range;
   fwp: data_words0p1_range;
   lastnl, ignore: data_words0_range;
   start_at, lines_before: integer;
   user_quit: boolean;
   state: (searching, found, attop, at_bottom, at_stop_line);

   { Locate a given string (specified by start and stop char positions) in a
     given file block (ditto). Upper/lower case may or may not be significant }

   function locatein(var block: data_chars_type;
                     bstart, bstop: data_chars_range;
                     var string: line_chars_type;
                     var low_string: line_chars_type;
                     sstart, sstop: line_chars_range;
                     backwards: boolean;
                     case_signif: boolean;
                     var fcp: data_chars_range): boolean;
      extern;                           { now written in PMA for speed }

   { Try to find in current block }

   function try_current_block(start, stop: data_words0p1_range): boolean;

   begin { try_current_block }
      with current_buffer, current_index^, entries[index_sub], block_ad^ do
      if start > stop
      then try_current_block := false   { nowhere to look }
      else try_current_block := locatein(data_chars,
                                         start*2 - 1, stop*2,
                                         string, low_string, sstart, sstop,
                                         backwards, case_signif, fcp)
   end { try_current_block } ;

begin { quick_locate }
   replace_line;
   state := searching;
   with current_buffer, current_index^, entries[index_sub] do
   begin
      if backwards then
      begin { move backwards in file }
         start_at := line_start - 1;
         if try_current_block(split_end, start_at)
         then state := found
         else
         begin { not found }
            if   start_at >= split_start
            then start_at := split_start - 1;
            if try_current_block(1, start_at)
            then state := found
            else
            begin { not found }
               close_split;
               repeat
                  if lines_above < stop_line
                  then state := at_stop_line
                  else if get_previous_block then
                  with current_index^, entries[index_sub] do
                  begin
                     page_in_block;     { ensure not paged out }
                     if try_current_block(1, split_start-1)
                     then state := found
                     else if main_state <> running then
                     begin
                        stop_line := lines_above + 1;
                        state := at_stop_line
                     end
                     else
                  end
                  else state := attop
               until state <> searching
            end { not found }
         end { not found }
      end { move backwards in file }
      else
      begin { move forwards in file }
         if stop_line = 0               { 0 => never stop on line number }
         then stop_line := maxint;
         start_at := line_end + 1;
         if try_current_block(start_at, split_start-1)
         then state := found
         else
         begin { not found in block }
            if   start_at <  split_end
            then start_at := split_end;
            if try_current_block(start_at, block_max_words)
            then state := found
            else
            begin { still not found }
               close_split;
               repeat
                  last_line_in_block := lines_above +
                     current_index^.entries[index_sub].block_lines;
                  if last_line_in_block >= stop_line
                  then state := at_stop_line
                  else if get_next_block(user_quit) then
                  with current_index^, entries[index_sub] do
                  begin { try next block }
                     page_in_block;
                     if try_current_block(1, split_start-1)
                     then state := found
                     else if main_state <> running then
                     begin { error }
                        stop_line := last_line_in_block;
                        state := at_stop_line
                     end { error }
                     else { not found }
                  end { try next block }
                  else state := at_bottom
               until state <> searching
            end { still not found }
         end { not found in block }
      end { move forwards in file } ;

      case state of
         found:
            with current_index^, entries[index_sub], block_ad^ do
            begin { set up the details of line found }
               fwp := (fcp + 1) div 2;  { word position }
               if fwp < split_start
               then lines_before := cntlines(data_words,1,fwp-1,lastnl)
               else lines_before := cntlines(data_words,1,split_start-1,ignore)
                                  + cntlines(data_words,split_end,fwp-1,lastnl);
               line_number := lines_above + lines_before + 1;
               find_next_newline(fwp, fwp, false);
               line_start := lastnl + 1;
               line_end := fwp;
               line_exists := true;
               line_status := normal;
               copy_in_line;
               line_position := 1;

               { we have found a line, but it may be beyond the stop line }

               if (not backwards and (line_number <= stop_line)) or
                  (    backwards and (line_number >= stop_line))
               then                     { it is ok }
               else load_a_line(stop_line, print_top_or_bottom)
            end { set up the details of line found } ;
         attop:
            load_a_line(0, print_top_or_bottom);
         at_bottom:
            load_a_line(maxint, print_top_or_bottom);
         at_stop_line:
            begin
               { go to top first because we do not have current line details }
               load_a_line(0, false);
               load_a_line(stop_line, print_top_or_bottom)
            end
      end { case }
   end { with }
end { quick_locate } ;

{ Test whether we have hit top or bottom }

procedure test_line_landed_on;                                                  { TEST_LINE_LANDED_ON }

begin { test_line_landed_on }
   { only test if not error, quit etc. }
   if main_state = running
   then with current_buffer do
   case line_status of
      top, bottom:
         main_state := top_or_bottom;
      normal:
   end
end { test_line_landed_on } ;

{ Record the current file place for future restoration }

procedure save_place(var the_place: file_places);                               { SAVE_PLACE }

begin { save_place }
   with current_buffer, the_place do
   begin
      saved_line := line_number;
      saved_state := line_status;
      saved_position := line_position
   end
end { save_place } ;

{ Return the file place to that previously recorded }

procedure restore_place(the_place: file_places);                                { RESTORE_PLACE }

begin { restore_place }
   with current_buffer, the_place do
   begin
      if saved_state = top
      then load_a_line(0, false)
      else load_a_line(saved_line, false);
      line_position := saved_position
   end
end { restore_place } ;

{ Insert a new line into the work file }
{ Procedure is:
   1) replace_line  (to ensure current line is in file )
   2) put new text into current line and set line_length
   3) insert_a_line
}

procedure insert_a_line;                                                        { INSERT_A_LINE }

begin { insert_a_line }
   with current_buffer do
   begin
      if line_exists                    { set new line number }
      then line_number := line_number + 1;
      if marked_line >= line_number then
      begin { keep line mark up to date }
         marked_line := marked_line + 1
         {---teststart---}
         ;if mode_test
         then writeln('marked_line = ', marked_line:1)
         {---teststop---}
      end { keep line mark up to date } ;
      if iw_marked_line >= line_number then
      begin { keep IW line mark up to date }
         iw_marked_line := iw_marked_line + 1
         {---teststart---}
         ;if mode_test
         then writeln('iw_marked_line = ', iw_marked_line:1)
         {---teststop---}
      end { keep IW line mark up to date } ;
      if point_line_no >= line_number then
      begin { keep point line number up to date }
         point_line_no := point_line_no + 1
         {---teststart---}
         ;if mode_test
         then writeln('point_line_no = ', point_line_no:1)
         {---teststop---}
      end { keep point line number up to date } ;
      line_start := line_end + 1;       { file copy is zero length }
      line_exists := true;
      line_altered := false;            { file copy is ok }
      line_status := normal;
      line_position := 1;
      with current_index^, entries[index_sub]  { add one to block line count }
      do block_lines := block_lines + 1;  { must be done before copy_out_line }
      copy_out_line                     { copy into file }
   end
end { insert_a_line } ;

{ Delete the current line }

procedure delete_line;                                                          { DELETE_LINE }

begin { delete_line }
   with current_buffer do
   if line_exists then
   begin
      line_exists := false;             { line no longer exists }
      file_altered := true;             { file has been changed }
      if marked_line > line_number then
      begin
         marked_line := marked_line - 1  { one line deleted }
         {---teststart---}
         ;if mode_test
         then writeln('marked_line = ', marked_line:1)
         {---teststop---}
      end
      else if marked_line = line_number then
      begin
         marked_line := 0               { marked line no longer exists }
         {---teststart---}
         ;if mode_test
         then writeln('marked_line = ', marked_line:1)
         {---teststop---}
      end;
      if iw_marked_line > line_number then
      begin
         iw_marked_line := iw_marked_line - 1  { one line deleted }
         {---teststart---}
         ;if mode_test
         then writeln('iw_marked_line = ', iw_marked_line:1)
         {---teststop---}
      end
      else if iw_marked_line = line_number then
      begin
         iw_marked_line := 0            { marked line no longer exists }
         {---teststart---}
         ;if mode_test
         then writeln('iw_marked_line = ', iw_marked_line:1)
         {---teststop---}
      end;
      if point_line_no > line_number then
      begin
         point_line_no := point_line_no - 1  { one line deleted }
         {---teststart---}
         ;if mode_test
         then writeln('point_line_no = ', point_line_no:1)
         {---teststop---}
      end
      else if point_line_no = line_number then
      begin
         point_line_no := 0;            { no longer exists }
         point_line_pos := 0
         {---teststart---}
         ;if mode_test
         then writeln('point_line_no = ', point_line_no:1)
         {---teststop---}
      end;
      with current_index^, entries[index_sub] do
      begin
         if block_lines <= 0
         then abort('delete_line: no lines in block')
         else block_lines := block_lines- 1;  { count one line deleted }
         paged_out_copy_ok := false
      end
   end
end { delete_line } ;

{ The line being copied in is longer than the maximum we can handle - split }
{ it up into manageable chunks.                                             }

procedure split_long_line;                                                      { SPLIT_LONG_LINE }

var
   copy_block: file_block;
   bindex, blast, space_count, chindex: integer;
   saved_file_place: file_places;
   old_file_altered, done: boolean;
   ch: char;

   { insert the built-up line into the file }

   procedure store_line;
   begin { store_line }
      with current_buffer do
      begin
         {---teststart---}
         if mode_test
         then writeln('split_long_line: inserting line.');
         {---teststop---}
         line_text[line_length+1] := newline;  { add newline at end }
         insert_a_line
      end
   end { store_line } ;

   { store a character in the line being built up }

   procedure store_ch(the_char: char);
   begin { store_ch }
      with current_buffer do
      begin
         if line_length >= line_max_charsm1 then
         begin { store full line in file }
            store_line;
            line_length := 1
         end { store full line in file }
         else line_length := line_length + 1;
         line_text[line_length] := the_char
      end
   end { store_ch } ;

begin { split_long_line }
   with current_buffer, current_index^, entries[index_sub] do
   begin
      old_file_altered := file_altered;
      copy_block := block_ad^;          { take copy of current file block }
      bindex := line_start*2 - 1;       { first and last characters of line }
      blast := line_end*2;
      {---teststart---}
      if mode_test
      then writeln('split_long_line: line_start = ',line_start:1,
                 '  line_end = ',line_end:1,
                 '  bindex = ',bindex:1,
                 '  blast = ',blast:1);
      {---teststop---}
      delete_line;                      { delete too-long line }
      replace_line;                     { update block to correspond }
      save_place(saved_file_place);
      line_length := 0;
      done := false;
      repeat
         if bindex > blast
         then done := true              { end of old line }
         else
         begin
            ch := copy_block.data_chars[bindex];
            bindex := bindex + 1;
            if ch = chr(dc1_code) then
            begin { compressed spaces }
               space_count := ord( copy_block.data_chars[bindex] );
               bindex := bindex + 1;
               for chindex := 1 to space_count
               do store_ch(' ')
            end { compressed spaces }
            else if ch = newline        { found newline at end }
            then done := true
            else store_ch(ch)
         end
      until done;
      store_line;                       { partially complete line }
      restore_place(saved_file_place);  { back to correct line }
      file_altered := old_file_altered  { do not set file_altered just because }
                                        { of splitting a long line }
   end { with }
end { split_long_line } ;

{ Display a message identifying the current buffer }

procedure announce_buffer_name;                                                 { ANNOUNCE_BUFFER_NAME }

begin { announce_buffer_name }
   with current_buffer, main_file do
   begin
      if treename.len = 0
      then message := 'Buffer ~  (No filename specified)'
      else message := concat('Buffer ~  pathname: ',treename.strng);
      ins_int(current_buffer_number, 1);
      screen_message(message, true)
   end { with } ;
   display_buffer_name := false
end { announce_buffer_name } ;

{ Display a message saying that the current buffer has been modified. }

procedure display_buffer_modified;                                              { DISPLAY_BUFFER_MODIFIED }

begin { display_buffer_modified }
   with current_buffer, main_file do
   begin
      message := 'Buffer ~ has been modified.';
      if treename.len > 0
      then insert(concat('(File: ',treename.strng,') '), message, 10);
      int_screen_message(message, true, current_buffer_number, 1)
   end { with }
end { display_buffer_modified } ;

{ Set up all the information representing an editor buffer.  When done the }
{ buffer holds an empty file. }

procedure init_buffer;                                                          { INIT_BUFFER }

begin { init_buffer }
   with current_buffer do
   begin
      index_sub := 1;
      block_number := 1;
      blocks := 1;
      memory_blocks := 0;               { 1 will be added when block allocated }
      new(first_index);
      index_block_count := index_block_count + 1;
      current_index := first_index;
      with first_index^ do
      begin
         top_entry := 1;
         previous := nil;
         next := nil;
         setup_empty_block
      end { with } ;
      set_to_top_of_file;               { sets all line related information }
      marked_line := 0;
      iw_marked_line := 0;
      point_line_no := 0;
      point_line_pos := 0;
      file_altered := false;
      file_truncated := false;
      with main_file do
      begin
         treename.strng := '';
         file_is_open := false;
         file_type := sam_type;
         original_pathname := false;
         rename_done := false;
         truncate_later := false;
         unit := 1
      end { with } ;
      must_redraw_window := true;
      some_lines_changed := false
   end { with }
end { init_buffer } ;

{ Empty a buffer that has been used }

procedure empty_buffer;                                                         { EMPTY_BUFFER }

var
   temp_ptr: ptr_index_block;
   eindex: index_range;

begin { empty_buffer }
   with current_buffer do
   begin
      while first_index <> nil do
      with first_index^ do
      begin
         for eindex := 1 to top_entry do  { loop to save file blocks and keys }
         save_entry_contents(entries[eindex]);
         temp_ptr := next;
         dispose(first_index);
         index_block_count := index_block_count - 1;
         first_index := temp_ptr
      end;
      if main_file.file_is_open
      then close_file(main_file)
   end { with }
end { empty_buffer } ;

{ Switch to a different editor buffer }

procedure switch_buffer(new_buffer_number: buffer_range);                       { SWITCH_BUFFER }

begin { switch_buffer }
   if new_buffer_number = current_buffer_number
   then { do nothing }
   else
   begin { new buffer not same one }
      multiple_buffers_used := true;
      switch_buffer_used := true;
      { create heap copy if necessary }
      if buffer_pointers[current_buffer_number].bptr = nil
      then new(buffer_pointers[current_buffer_number].bptr);
      { copy out to heap }
      buffer_pointers[current_buffer_number].bptr^ := current_buffer;
      current_buffer_number := new_buffer_number;
      if buffer_pointers[current_buffer_number].bptr = nil
      then init_buffer                  { first use of buffer }
      else current_buffer := buffer_pointers[current_buffer_number].bptr^;
      page_in_block                     { ensure current block is online }
   end { new buffer not same one }
end { switch_buffer } ;

{ Find the next chain buffer moving forwards or backwards.       }
{ Only called when mode_chain is true.                           }
{ Switches to the new buffer if found and sets correct position. }

function find_next_chain_buffer(backwards, reposition: boolean): boolean;       { FIND_NEXT_CHAIN_BUFFER }

var
   temp_buffer: buffer0_range;
   state: search_type;

begin { find_next_chain_buffer }
   temp_buffer := current_buffer_number;
   state := searching;
   repeat
      if backwards
      then temp_buffer := buffer_pointers[temp_buffer].pred_buff
      else temp_buffer := buffer_pointers[temp_buffer].succ_buff;
      if temp_buffer = 0
      then state := not_found           { end of chain }
      else if buffer_pointers[temp_buffer].bptr = nil
      then { try the next }
      else state := found               { non-null buffer found }
   until state <> searching;
   if state = found then
   begin { chain buffer found }
      switch_buffer(temp_buffer);
      display_buffer_name := true;
      if reposition then
      begin { set file position ready for use }
         if backwards
         then load_a_line(maxint, false)
         else load_a_line(0     , false)
      end { set file position ready for use } ;
      find_next_chain_buffer := true
   end { chain buffer found }
   else find_next_chain_buffer := false
end { find_next_chain_buffer } ;

{ Go to top or bottom of file, allowing for mode_chain if necessary }

procedure top_or_bottom_proc(backwards: boolean);                               { TOP_OR_BOTTOM_PROC }

var
   buffer_changed: boolean;

begin { top_or_bottom_proc }
   if mode_chain then
   begin { go to end of chain }
      repeat buffer_changed := find_next_chain_buffer(backwards, false)
      until (not buffer_changed) or (main_state <> running);
      if in_window_code
      then { buffer name will be printed later }
      else if display_buffer_name
      then announce_buffer_name
   end { go to end of chain } ;
   if backwards
   then load_a_line(0     , false)
   else load_a_line(maxint, false)
end { top_or_bottom_proc } ;

{ Size the current editing buffer if not open }

procedure size_edit_buffer(var the_lines, the_size: integer);                   { SIZE_EDIT_BUFFER }

var
   saved_file_place: file_places;
   finished, user_quit: boolean;

begin { size_edit_buffer }
   with current_buffer do
   begin
      save_place(saved_file_place);
      load_a_line(maxint, false);       { go to bottom to ensure all read in }
                                        { and file unit closed }
      if main_state = running then
      begin { reached bottom of file }
         the_lines := line_number - 1;  { lines in file }
         load_a_line(0, false);         { start at top of file }
         the_size := 0;
         finished := false;
         repeat
            with current_index^, entries[index_sub]
            do the_size := the_size + split_start - 1;
            if get_next_block(user_quit)
            then { no need to page it in }
            else finished := true
         until finished or user_quit;
         if user_quit
         then the_size := -1
      end { reached bottom of file }
      else
      begin { failed to reach bottom }
         the_lines := -1;
         the_size := -1
      end { failed to reach bottom } ;
      load_a_line(0, false);            { we do not have current block info }
      restore_place(saved_file_place)   { restore file position }
   end { with }
end { size_edit_buffer } ;

{ List all non-empty buffer filenames etc. }

procedure list_buffers(show_size: boolean);                                     { LIST_BUFFERS }

var
   saved_buffer_number, bindex: buffer_range;
   chindex: 1..maxint;
   total_buffer_lines, total_buffer_size, total_buffer_records,
   buffers_listed: integer;
   saved_switch_buffer_used: boolean;

   procedure print_buffer_info(this_buffer_number: buffer_range);

   var
      window_number, buffer_lines, buffer_size: integer;
      windex: window_range;

   begin { print_buffer_info }
      with current_buffer, main_file do
      begin
         buffers_listed := buffers_listed + 1;
         { size buffer now in case user breaks in causing 'message' }
         { to be blatted by the 'Quit' message }
         if show_size
         then size_edit_buffer(buffer_lines, buffer_size);
         if main_state = running then
         begin { not interrupted }
            if this_buffer_number = saved_buffer_number
            then message := '->~'
            else message := '  ~';
            ins_int(bindex, 4);
            if window_count > 0 then
            begin { insert window number }
               window_number := 0;
               for windex := 1 to window_count do
               with window_array[windex] do
               begin
                  if window_buffer = this_buffer_number
                  then window_number := windex
               end { for loop } ;
               if window_number = 0
               then append_message('       ')  { not in window }
               else
               begin { is in window }
                  append_message('   ~');
                  ins_int(window_number, 4)
               end { is in window }
            end { insert window number } ;
            if show_size then
            begin { show size information }
               { buffer information has already been calculated }
               append_message(' ~');
               ins_int(buffer_lines, 8);
               append_message(' ~');
               total_buffer_lines := total_buffer_lines + buffer_lines;
               ins_int(buffer_size, 10);
               if buffer_size = -1
               then { unknown }
               else
               begin { calculate size in records }
                  total_buffer_size := total_buffer_size + buffer_size;
                  buffer_size := (buffer_size + 1023) div 1024;
                  if buffer_size = 0
                  then buffer_size := 1;
                  total_buffer_records := total_buffer_records + buffer_size
               end { calculate size in records } ;
               append_message(' ~');
               ins_int(buffer_size, 8)
            end { show size information }
            else
            begin { show mod and position }
               if line_altered or file_altered
               then append_message(' mod ')
               else append_message('     ');
               case line_status of
                  top:    append_message('    top     ');
                  bottom: append_message('   bottom   ');
                  normal:
                     begin
                        append_message('~');
                        ins_int(line_number, 7);
                        if line_position = 1
                        then append_message('     ')
                        else
                        begin { not at col 1 }
                           append_message('.~');
                           ins_int(line_position, -4)
                        end { not at col 1 }
                     end { normal line }
               end { case }
            end { show mod and position } ;
            append_message('  ');
            if treename.len > 0
            then append_message(treename.strng)
            else append_message('No filename specified.');
            if file_is_open
            then append_message('  (open)');
            if file_truncated
            then append_message('  (truncated)');
            screen_message(message, false)
         end { not interrupted }
      end { with }
   end { print_buffer_info } ;

begin { list_buffers }
   saved_switch_buffer_used := switch_buffer_used;
   message := 'Buffer';
   if window_count > 0
   then append_message(' window');
   if show_size
   then append_message('    lines      words  records')
   else append_message(' mod?   position ');
   append_message('  filename');
   screen_message(message, false);
   total_buffer_lines   := 0;
   total_buffer_size    := 0;
   total_buffer_records := 0;
   buffers_listed       := 0;
   for chindex := 1 to length(message)
   do if message[chindex] <> ' '
      then message[chindex] := '-';
   screen_message(message, false);
   saved_buffer_number := current_buffer_number;
   for bindex := 1 to buffer_max do
   begin
      if (main_state = running) and continue_screen_messages then
      begin { carry on listing }
         if bindex = current_buffer_number  { first or only buffer }
         then print_buffer_info(bindex)
         else if buffer_pointers[bindex].bptr <> nil then
         begin { used buffer }
            switch_buffer(bindex);
            print_buffer_info(bindex)
         end { used buffer }
      end { carry on listing }
   end { for loop } ;
   switch_buffer(saved_buffer_number);
   if show_size and (buffers_listed > 1) and (main_state = running) then
   begin { show totals }
      message := '          -------------------------';
      if window_count > 0 then insert('       ', message, 1);
      screen_message(message, false);
      message := '      ';
      if window_count > 0 then append_message('       ');
      append_message(' ~ ~ ~');
      ins_int(total_buffer_lines  ,  8);
      ins_int(total_buffer_size   , 10);
      ins_int(total_buffer_records,  8);
      screen_message(message, false)
   end { show totals } ;
   { do not set switch_buffer_used here because 'we were only looking' }
   switch_buffer_used := saved_switch_buffer_used;
   {---teststart---}
   if mode_test
   then dbg_print                       { print out all buffer information }
   {---teststop---}
end { list_buffers } ;

{ Find next used buffer, forwards or backwards }

procedure find_next_used_buffer(forwards: boolean;                              { FIND_NEXT_USED_BUFFER }
                                var new_buffer_number: buffer_range);

var
   state: search_type;

begin { find_next_used_buffer }
   new_buffer_number := current_buffer_number;
   state := searching;
   repeat
      { Move forwards or backwards, cycling round at ends }
      if forwards
      then if new_buffer_number = buffer_max
           then new_buffer_number := 1
           else new_buffer_number := succ(new_buffer_number)
      else if new_buffer_number = 1
           then new_buffer_number := buffer_max
           else new_buffer_number := pred(new_buffer_number);
      if new_buffer_number = current_buffer_number
      then state := not_found
      else if buffer_pointers[new_buffer_number].bptr <> nil
      then state := found
   until state <> searching
end { find_next_used_buffer } ;

{ Close a primos file }

procedure close_file;                                                           { CLOSE_FILE }
{ var pfile: primos_file }

var
   tipe, code, rnw: shortint;
   saved_buffer_number: buffer_range;
   posin: integer;

begin { close_file }
   with pfile, current_buffer do
   if load_use = use_buffer then
   begin { close buffer access }
      saved_buffer_number := current_buffer_number;
      switch_buffer(load_buffer_number);
      load_a_line(0, false);            { leave at top of file }
      switch_buffer(saved_buffer_number)
   end { close buffer access }
   else
   begin { close Primos file }
      if truncate_later then
      begin { truncate after writing }
         posin := 0;
         prwf$$(k$trnc, unit, 0, 0, posin, rnw, code);
         if code <> 0
         then error_print(k$irtn, code, concat('Truncating ',treename.strng),
                          'PRWF$$')
      end { truncate after writing } ;
      close_unit(unit, code);
      if code <> 0
      then error_print(k$irtn, code, concat('Closing ',treename.strng),'SRSFX$')
   end { close Primos file } ;
   pfile.file_is_open := false
end { close_file } ;

{ Open a primos file or editor buffer with the key given - adds k$getu to key }
{ for files.  expected_size is used to preset CAM file size; set  zero if not }
{ known.                                                                      }

procedure open_file(key: integer;                                               { OPEN_FILE }
                    var pfile: primos_file;
                    expected_size: integer;
                    allow_file, allow_buffer: boolean);

type
   three_way = (as_str, as_tree, as_word);

var
   pruned_tree, attributes: tree_type;
   attrib: record
      case three_way of
         as_str:   (strng: tree_string);
         as_tree:  (lent: shortint; charst: tree_chars);
         as_word:  (lenw: shortint; charsw: word)
      end;
   lparen_pos, rparen_pos, slash_pos, chindex: tree0_range;
   tipe, rnw, code, close_code: shortint;
   append, ok_to_overwrite, backup_worked: boolean;
   saved_buffer_number: buffer_range;
   use_key, buffer_number_spec, file_position, posin: integer;

   { Check whether it is alright to overwrite an output file }

   function alright_to_overwrite: boolean;

   var
      alright: boolean;

   begin { alright_to_overwrite }
      with pfile, pruned_tree do
      begin
         if (not mode_safety) or        { only check if asked }
            (key = k$read) or           { reading is always alright }
            append or                   { append does not destroy anything }
            original_pathname or        { replacing original file }
            cominput_open               { do not prompt non-existent user }
         then alright := true
         else
         begin { need to check for existence }
            if file_exists(strng) then
            begin { file already exists }
               alright := question_and_answer(
                  concat('File ',strng,' already exists - OK to overwrite? '),
                  true, false)
            end { file already exists }
            else alright := true        { not found }
         end { need to check for existence } ;
         alright_to_overwrite := alright
      end { with }
   end { alright_to_overwrite } ;

   { MODE_BACKUP: Rename file about to be overwritten as backup file. }
   { Only do it first time of saving.                                 }

   procedure rename_backup_file(var backup_worked: boolean);

   var
      last_gt, bindex: integer;
      chindex: tree_range;
      dir_part, entry_part: tree_string;
      command: long_string;
      code, code1: shortint;
      temp: string[4];
      old_name, new_name: record
         case boolean of
            false: (len: shortint; chars: char32);
            true:  (strng: string32)
         end;

   begin { rename_backup_file }
      with pfile, pruned_tree do
      begin
         backup_worked := true;
{        writeln('rename_done = ',rename_done);  {----}
         if rename_done
         then { do not do it again so that proper backup is preserved }
         else
         begin { do the rename }
            rename_done := true;
            { split filename into dir/entry }
            last_gt := 0;
            for chindex := 1 to length(strng)
            do if strng[chindex] = '>'
               then last_gt := chindex;
            if last_gt = 0 then
            begin { not pathname }
               dir_part := '*';
               entry_part := strng
            end { not pathname }
            else
            begin { is pathname }
               dir_part := substr(strng, 1, last_gt-1);
               entry_part := substr(strng, last_gt+1, length(strng) - last_gt)
            end { is pathname } ;
            if length(entry_part) > 27
            then screen_message('Unable to keep backup copy of file because name is longer than 27 characters.', true)
            else
            begin { name not too long }
               if dir_part = '*'
               then code := 0           { no need to attach }
               else
               begin { attach to dir_part }
                  at$(k$setc, dir_part, code);
                  if code <> 0
                  then error_print(k$irtn, code, dir_part, 'AT$')
               end { attach to dir_part } ;
               if code = 0 then
               begin { attach alright }
                  { Delete file.BAKn where n is the max }
                  str(max_backup, temp);
                  old_name.strng := concat(entry_part,'.BAK',temp);
                  fil$dl(old_name.strng, code);
                  if (code = 0) or (code = e$fntf)
                  then { no error }
                  else error_print(k$irtn, code, old_name.strng, 'FIL$DL');
                  { Rename file all backups as one older than now }
                  for bindex := max_backup downto 1 do
                  begin
                     str(bindex,temp);
                     new_name.strng := concat(entry_part,'.BAK',temp);
                     if bindex = 1 then
                     begin { copy actual file }
                        if file_exists(entry_part) then
                        begin { file exists }
                           command := concat('COPY ',
                                      dir_part,'>',entry_part,
                                      ' ',
                                      dir_part,'>',new_name.strng,
                                      ' -DTM -NQ');
                        {  screen_message(command, false);  {----}
                           cp$(command, code1, code);
                           { ignore any warning return from COPY: could be }
                           { 'failed to set DTM' or some such }
                           backup_worked := (code1 = 0) and (code <= 0)
                        end { file exists }
                        else backup_worked := true
                     end { copy actual file }
                     else
                     begin { bindex <> 1 }
                        str(bindex-1,temp);
                        old_name.strng := concat(entry_part,'.BAK',temp);
                        cnam$$(old_name.chars, old_name.len,
                               new_name.chars, new_name.len,
                               code);
                        if (code = 0) or (code = e$fntf)
                        then { no error }
                        else
                        begin
                           error_print(k$irtn, code,
                              concat('CNAME ',old_name.strng,' ',new_name.strng),
                              'CNAM$$')
                        end
                     end { bindex <> 1 }
                  end { for loop } ;
                  attach_home
               end { attach alright }
            end { name not too long }
         end { do the rename }
      end { with }
   end { rename_backup_file } ;

   { For CAM files we preset the physical file size to the size we have }
   { calculated for the file }

   procedure set_cam_file_extent(physical_size: integer);

   var
      size_given: integer;
      code: shortint;

      procedure cf$ext(unit: shortint;
                       req_peof: integer;
                       var act_peof: integer;
                       var code: shortint);
         extern;

   begin { set_cam_file_extent }
      with load_file do
      begin
         {---teststart---}
         if mode_test
         then writeln('physical_size = ',physical_size:1);
         {---teststop---}
         cf$ext(unit, physical_size, size_given, code);
         if code = 0 then
         begin { worked }
            {---teststart---}
            if mode_test
            then writeln('size_given = ',size_given:1)
            {---teststop---}
         end { worked }
         else error_print(k$irtn, code, 'Setting CAM file size', 'CF$EXT')
      end { with }
   end { set_cam_file_extent } ;

begin { open_file }
   with pfile, pruned_tree do
   begin

      { remove (attributes) from end if present and analyse }

      append := false;
      lparen_pos := pos('(', treename.strng);
      if lparen_pos = 0
      then pruned_tree.strng := treename.strng
      else
      begin { attributes present }
         pruned_tree.strng := substr(treename.strng, 1, lparen_pos-1);
         rparen_pos := pos(')', treename.strng);
         if rparen_pos <= lparen_pos then
         begin { right before left }
            str_screen_message('Error in attributes specification: ~', true,
                                  treename.strng);
            main_state := command_error
         end { right before left }
         else
         begin { parens alright }
            attributes.strng := substr(treename.strng, lparen_pos+1,
                                       rparen_pos-lparen_pos-1);
            while attributes.len > 0 do
            begin
               slash_pos := pos('/',attributes.strng);
               if slash_pos = 0 then
               begin { no slash present }
                  attrib.strng := attributes.strng;
                  attributes.strng := ''
               end { no slash present }
               else
               begin { slash found }
                  attrib.strng := substr(attributes.strng,1,slash_pos-1);
                  attributes.strng := substr(attributes.strng,slash_pos+1,
                                             attributes.len-slash_pos)
               end { slash found } ;
               if attrib.lenw > word_max_chars
               then attrib.lenw := word_max_chars;
               for chindex := attrib.lenw+1 to word_max_chars
               do attrib.charsw[chindex] := ' ';
               if compare(attrib.charsw,'APPEND  ')
               then append := true
               else if compare(attrib.charsw,'SAM     ')
               then file_type := sam_type
               else if compare(attrib.charsw,'DAM     ')
               then file_type := dam_type
               else if compare(attrib.charsw,'CAM     ')
               then file_type := cam_type
               else
               begin { attribute not recognised }
                  str_screen_message('Attribute ~ not recognised.', true,
                                     attrib.strng);
                  main_state := command_error
               end { attribute not recognised }
            end { while loop }
         end { attributes OK }
      end { attributes present } ;

      { decide whether we are opening a real file or a buffer }

      file_is_open := false;
      if main_state = running then
      begin { alright so far }
         if chars[1] in ['0'..'9'] then
         begin { opening buffer }
            load_use := use_buffer;
            if allow_buffer then
            begin { allowed to use buffer }
               saved_buffer_number := current_buffer_number;
               if tree_to_dec(pruned_tree, buffer_number_spec) then
               begin { conversion alright }
                  if (buffer_number_spec >= 1) and
                     (buffer_number_spec <= buffer_max)
                  then with current_buffer do
                  begin { buffer number in range }
                     load_buffer_number := buffer_number_spec;
                     if load_buffer_number = current_buffer_number
                     then screen_message('Cannot load/unload current buffer',
                                         true)
                     else if key = k$read then
                     begin { open buffer for reading }
                        if buffer_pointers[load_buffer_number].bptr = nil
                        then int_screen_message('Buffer ~ is empty', true,
                                                load_buffer_number, 1)
                        else
                        begin { buffer is not empty }
                           switch_buffer(load_buffer_number);
                           load_a_line(maxint, false);  { ensure all read in }
                           load_a_line(0, false);
                           file_altered := false;  { clear this now that the }
                                        { buffer is loaded elsewhere }
                           load_index := first_index;
                           load_index_sub := 1;
                           file_is_open := true
                        end { buffer is not empty }
                     end { open buffer for reading }
                     else
                     begin { open buffer for writing }
                        switch_buffer(load_buffer_number);
                        if (line_altered or file_altered) and (not append)
                        then
                        begin { buffer modified }
                           display_buffer_modified;
                           ok_to_overwrite :=
                              question_and_answer('OK to overwrite? ', true,
                                                  false)
                        end { buffer modified }
                        else ok_to_overwrite := true;
                        if ok_to_overwrite then
                        begin { ok to overwrite }
                           if append
                           then load_a_line(maxint, false)
                           else
                           begin { not append }
                              empty_buffer;
                              init_buffer
                           end { not append } ;
                           load_index := current_index;
                           load_index_sub := index_sub;
                           file_is_open := true;
                           must_redraw_window := true
                        end { OK to overwrite buffer }
                        else screen_message('Function abandoned', false)
                     end { open buffer for writing } ;
                     switch_buffer(saved_buffer_number)
                  end { buffer number in range }
                  else int_screen_message('Buffer number must be 1..~',
                                          true, buffer_max, 1);
               end { conversion alright }
               else screen_message('Error in buffer number', true)
            end { allowed to use buffer }
            else screen_message('Buffer number not allowed', true)
         end { opening buffer }
         else
         begin { opening Primos file }
            load_use := use_primos;
            if not allow_file
            then screen_message('Only buffer number allowed', true)
            else if not alright_to_overwrite
            then { user does not want to overwrite }
            else
            begin { file allowed and ok to overwrite }
               if (key = k$writ) and mode_backup and
                  (not cominput_open) and (not append)
               then
               begin { take backup(s) }
                  rename_backup_file(backup_worked);
                  if not backup_worked then
                  begin { backup operation aborted }
                     screen_message('Failed to take backup copy of file.',
                                    true);
                     if question_and_answer('Carry on and overwrite file? ',
                                            true, false)
                     then backup_worked := true
                  end { backup operation aborted }
               end { take backup(s) }
               else backup_worked := true;
               if backup_worked then
               begin { did backup alright }
                  truncate_later := false;
                  tipe := 0;
                  use_key := key + k$getu;
                  if file_type = dam_type
                  then use_key := use_key + k$ndam
                  else if file_type = cam_type
                  then use_key := use_key + k$ncam;
                  call_srsfx$(use_key, strng, unit, tipe, code);
                  if code = e$fius then
                  begin { file is in use }
                     { try to close it by name to please the user }
                     call_srsfx$(k$clos, strng, unit, tipe, close_code);
                     if close_code = 0 then
                     begin { close successful - try open again }
                        call_srsfx$(use_key, strng, unit, tipe, code)
                     end { close successful - try open again }
                  end { file is in use } ;
                  if code <> 0
                  then error_print(k$irtn, code, strng, 'SRSFX$')
                  else if (tipe >= 2) and (tipe <= 4) then
                  begin { object is a directory }
                     screen_message('Object is a directory', true);
                     close_file(pfile)
                  end { object is a directory }
                  else
                  begin { not a directory }
                     file_is_open := true;
                     file_type := tipe;  { copy from actual file type }
                     original_pathname := true;  { this one established now }
                     if key=k$writ then
                     begin { open for writing }
                        if append then
                        begin { position to end of file }
                           posin := maxint;
                           prwf$$(k$posn, unit, 0, 0, posin, rnw, code);
                           if code = e$eof
                           then code := 0;  { allow for end of file }
                           if code <> 0 then
                           begin { positioning error }
                              error_print(k$irtn, code,
                                          concat('Positioning to end of ',strng),
                                          'PRWF$$');
                              close_file(pfile)
                           end { positioning error }
                        end { position to end of file }
                        else truncate_later := true;  { truncate output file when closed }
                                        { to avert disc quota problem }
                        { Preset physical extent if CAM file }
                        if (tipe = cam_type) and (expected_size > 0) then
                        begin { set CAM file size }
                           { find current position }
                           prwf$$(k$rpos, unit, 0, 0, file_position, rnw, code);
                           if code = 0 then
                           begin { got file position alright }
                                        {---teststart---}
                              if mode_test
                              then writeln('file_position = ',file_position:1);
                                        {---teststop---}
                              set_cam_file_extent(file_position + expected_size)
                           end { got file position alright }
                           else error_print(k$irtn, code, 'Getting file position',
                                            'PRWF$$')
                        end { set CAM file size }
                     end { open for writing } ;
                     prepos := 0
                  end { file is not a directory }
               end { did backup alright }
               else
               begin { backup operation failed }
                  screen_message('Operation terminated.', true)
               end { backup operation failed }
            end { file allowed and ok to overwrite }
         end { opening Primos file }
      end { treename analysed OK }
   end { with }
end { open_file } ;

{ Load a file or buffer into the current buffer }

function load_a_file: boolean;                                                  { LOAD_A_FILE }

var
   line_number_before, last_line_read: integer;

begin { load_a_file }
   replace_line;                        { ensure line copied to file }
   with load_file, current_buffer do
   begin
      original_pathname := false;
      rename_done := false;
      open_file(k$read, load_file, 0, true, true);
      if file_is_open then
      begin { opened alright }
         load_a_file := true;           { opened ok }
         if line_exists
         then line_number_before := line_number
         else line_number_before := line_number - 1;
         move_split;                    { ensure split is below current line }
         if load_use = use_primos
         then read_a_block(load_file, last_line_read)
         else copy_from_buffer(last_line_read);
         while file_is_open and (main_state = running) do
         begin
            expand_split(block_max_words);
            if load_use = use_primos
            then read_a_block(load_file, last_line_read)
            else copy_from_buffer(last_line_read)
         end { while loop } ;
         close_file(load_file);         { in case of error or quit }
         last_line_read := last_line_read + lines_above;  { actual number }
         { go to top first because we do not have current line information }
         load_a_line(0, false);
         load_a_line(last_line_read, false);
         if last_line_read <> line_number_before
         then file_altered := true;     { some lines actually loaded }
         if marked_line > line_number_before then
         begin
            marked_line := marked_line +
               (last_line_read - line_number_before)
            {---teststart---}
            ;if mode_test
            then writeln('marked_line = ', marked_line:1)
            {---teststop---}
         end;
         if iw_marked_line > line_number_before then
         begin
            iw_marked_line := iw_marked_line +
               (last_line_read - line_number_before)
            {---teststart---}
            ;if mode_test
            then writeln('iw_marked_line = ', iw_marked_line:1)
            {---teststop---}
         end;
         if point_line_no > line_number_before then
         begin
            point_line_no := point_line_no +
               (last_line_read - line_number_before)
            {---teststart---}
            ;if mode_test
            then writeln('point_line_no = ', point_line_no:1)
            {---teststop---}
         end
      end { opened alright }
      else load_a_file := false
   end { with }
end { load_a_file } ;

{ Restore the current line to its state before it was changed }

procedure oops_proc;                                                            { OOPS_PROC }

begin { oops_proc }
   with current_buffer do
   case line_status of
      top, bottom: print_line;          { print top or bottom }
      normal:
         begin
            update_changed_lines(line_number);
            if not line_exists then     { restoring deleted line}
            with current_index^, entries[index_sub] do
            begin
               block_lines := block_lines + 1;  { one more line in block }
               paged_out_copy_ok := false;
               if marked_line >= line_number then
               begin
                  marked_line := marked_line + 1
                  {---teststart---}
                  ;if mode_test
                  then writeln('marked_line = ', marked_line:1)
                  {---teststop---}
               end;
               if iw_marked_line >= line_number then
               begin
                  iw_marked_line := iw_marked_line + 1
                  {---teststart---}
                  ;if mode_test
                  then writeln('iw_marked_line = ', iw_marked_line:1)
                  {---teststop---}
               end;
               if point_line_no >= line_number then
               begin
                  point_line_no := point_line_no + 1
                  {---teststart---}
                  ;if mode_test
                  then writeln('point_line_no = ', point_line_no:1)
                  {---teststop---}
               end
            end;
            if line_end < line_start
            then abort('oops_proc: restoring a null line');
            copy_in_line;
            verify_print
         end
   end { case }
end { oops_proc } ;

{ Open the pathname given and set up the work file }

function open_edit_file: boolean;                                               { OPEN_EDIT_FILE }

var
   last_line_read: integer;
   worked: boolean;

begin { open_edit_file }
   with current_buffer, main_file do
   begin
      worked := true;
      if treename.len > 0 then
      with main_file do
      begin { open the file }
         open_file(k$read, main_file, 0, true, false);
         if file_is_open
         then read_a_block(main_file, last_line_read)  { read first block }
         else worked := false           { failed to open main file }
      end { open the file } ;
      open_edit_file := worked
   end
end { open_edit_file } ;

{ Set EDIT or INPUT mode }

procedure set_edit_mode(newmode: boolean);                                      { SET_EDIT_MODE }

begin { set_edit_mode }
   if input_state = user_input then
   begin
      edit_mode := newmode;             { set correct mode }
      if edit_mode                      { inform user now }
      then screen_message('Edit', false)
      else change_to_input_mode         { prints banner if necessary }
   end
   else edit_mode := true               { always obey init file in edit mode }
end { set_edit_mode } ;

{ Write the current editing buffer out to a file }

function write_edit_buffer: boolean;                                            { WRITE_EDIT_BUFFER }

var
   saved_file_place: file_places;
   written_ok, finished, user_quit: boolean;
   code: shortint;
   buffer_lines, buffer_size: integer;

   { Write the text of the current block to file. }

   procedure write_a_block(var written_ok: boolean);

   var
      rnw, code: shortint;
      posin: integer;

   begin { write_a_block }
      with current_buffer, current_index^, entries[index_sub], block_ad^,
           load_file do
      begin
         posin := 0;
         prwf$$(k$writ, unit, addressof( data_words[1] ),
                split_start - 1, posin, rnw, code);
         written_ok := code = 0;
         if code <> 0
         then error_print(k$irtn, code, concat('Writing ',treename.strng),'PRWF$$')
      end { with }
   end { write_a_block } ;

begin { write_edit_buffer }
   with current_buffer do
   begin
      save_place(saved_file_place);
      { ensure all file read in, and find size }
      size_edit_buffer(buffer_lines, buffer_size);
      {---teststart---}
      if mode_test
      then writeln('buffer_lines = ',buffer_lines:1,
                   '  buffer_size = ',buffer_size:1);
      {---teststop---}
      if main_state = running then
      begin { user has not quit }
         load_file := main_file;        { use load_file because get_next_block }
                                        { tests main_file.file_is_open }
         open_file(k$writ, load_file, buffer_size, true, false);
         if load_file.file_is_open then
         begin { open succeeded }
            main_file.file_type := load_file.file_type;
            main_file.original_pathname := load_file.original_pathname;
            main_file.rename_done := load_file.rename_done;
            load_a_line(0, false);      { start at top of file }
            finished := false;
            repeat
               write_a_block(written_ok);
               if get_next_block(user_quit)
               then page_in_block
               else finished := true
            until finished or (not written_ok) or user_quit;
            close_file(load_file);      { close the file }
            if written_ok
            then file_altered := false  { file copy now ok }
         end { open succeeded }
         else written_ok := false
      end { user has not quit }
      else written_ok := false;
      if written_ok then
      begin
         if command_line_args.report_sw and (current_buffer_number = 1) then
         begin { record filename for -REPORT option }
            set_global(report_gv_name, load_file.treename.strng, code);
            if code <> 0
            then error_print(k$irtn, code, 'Reporting FILE name', 'GV$SET')
         end { record filename for -REPORT option }
      end
      else main_state := command_error;
      write_edit_buffer := written_ok;
      load_a_line(0, false);            { we do not have current block info }
      restore_place(saved_file_place)   { restore file position }
   end { with }
end { write_edit_buffer } ;

{ Do QUIT and QF commands }

procedure quit_proc(is_qf_comm: boolean);                                       { QUIT_PROC }

var
   ok_to_quit, modified: boolean;
   bindex: buffer_range;
   state: search_type;
   temp_ptr: ptr_buffer_info;

   { close the editing file open in a buffer if necessary }

   procedure close_down(var the_buffer: buffer_info);
   begin { close_down }
      with the_buffer do
      begin
         if main_file.file_is_open
         then close_file(main_file)
      end
   end { close_down } ;

begin { quit_proc }
   if is_qf_comm
   then  ok_to_quit := true
   else if multiple_buffers_used then
   begin { BUFFER command used }
      { test for any buffer modified }
      bindex := 1;
      state := searching;
      repeat
         if bindex = current_buffer_number
         then with current_buffer
              do modified := line_altered or file_altered
         else
         begin { not current buffer }
            temp_ptr := buffer_pointers[bindex].bptr;
            if temp_ptr = nil
            then modified := false
            else with temp_ptr^
                 do modified := line_altered or file_altered
         end { not current buffer } ;
         if modified
         then state := found
         else if bindex = buffer_max
              then state := not_found
              else bindex := bindex + 1
      until state <> searching;
      if state = found
      then ok_to_quit :=
         question_and_answer('Buffer(s) modified - ok to quit? ', true, false)
      else ok_to_quit := true
   end { BUFFER command used }
   else with current_buffer do
   begin { BUFFER command not used }
      if file_altered or line_altered then
      begin
         ok_to_quit := question_and_answer(
            'Is it alright to lose the edits you have done? ', true, false)
      end
      else ok_to_quit := true
   end { BUFFER command not used } ;
   if ok_to_quit then
   begin { go ahead and quit }
      if paging_file_open
      then close_paging_file(false);
      for bindex := 1 to buffer_max     { close all files being edited }
      do if bindex = current_buffer_number
         then close_down(current_buffer)
         else
         begin { not current buffer }
            temp_ptr := buffer_pointers[bindex].bptr;
            if temp_ptr <> nil
            then close_down(temp_ptr^)
         end { not current buffer } ;
      main_state := quit_comm
   end { go ahead and quit }
   else
   begin { user says no }
      if multiple_buffers_used
      then screen_message('Please FILEALL.', false)
      else screen_message('Please FILE.', false)
   end { user says no }
end { quit_proc } ;

{ Perform a SAVE operation }

function save_proc(new_treename: tree_type; print_name: boolean): boolean;      { SAVE_PROC }

var
   old_treename: tree_type;
   result: boolean;

begin { save_proc }
   with current_buffer, main_file do
   begin
      old_treename := treename;         { preserve old in case of error }
      if new_treename.len > 0 then
      begin { new tree name given }
         if new_treename.strng <> treename.strng then
         begin { it is different }
            original_pathname := false;
            rename_done := false
         end { it is different } ;
         treename := new_treename
      end { new tree name given } ;
      if treename.len = 0 then
      begin { no treename }
         screen_message('Filename must be specified.', true);
         save_proc := false
      end { no treename }
      else
      begin { treename not null }
         if print_name
         then write_tree(main_file);    { remind user of filename }
         result := write_edit_buffer;   { do the writing of the file }
         if (not result) and            { if failed and }
            (new_treename.len > 0)      { new treename was given }
         then treename := old_treename;  { restore old treename after error }
         save_proc := result
      end { treename not null }
   end { with }
end { save_proc } ;

{ Save all the buffers which have been modified.  If at_logout is set then }
{ generate special names for saves when LOGOUT$ raised.                    }

procedure saveall_proc(at_logout: boolean);                                     { SAVEALL_PROC }

var
   saved_buffer_number, bindex: buffer_range;
   saved_count, error_count: integer;
   saved_switch_buffer_used, heading_done: boolean;

   procedure save_if_altered;

   var
      suffix: string[10];

   begin { save_if_altered }
      with current_buffer, main_file do
      begin
         if line_altered or file_altered then
         begin { it has been changed }
            if at_logout then
            with treename do
            begin { generate special name }
               str(current_buffer_number, suffix);
               strng := concat('FILE_SAVED_AT_LOGOUT',suffix);
               original_pathname := true;  { do not check for overwriting }
               rename_done := true      { do not try to rename }
            end { generate special name } ;
            if not heading_done then
            begin
               screen_message('Buffer  Filename', false);
               heading_done := true
            end;
            message := '~    ';
            ins_int(current_buffer_number, 4);
            if treename.len = 0 then
            begin
               append_message('No filename - not saved.');
               screen_message(message, false);
               error_count := error_count + 1
            end
            else
            begin
               append_message(treename.strng);
               screen_message(message, false);
               if write_edit_buffer
               then saved_count := saved_count + 1
               else
               begin
                  error_count := error_count + 1;
                  main_state := running  { otherwise all others will fail! }
               end
            end { filename set }
         end { buffer altered }
      end { with }
   end { save_if_altered } ;

begin { saveall_proc }
   saved_count := 0;
   error_count := 0;
   saved_buffer_number := current_buffer_number;
   saved_switch_buffer_used := switch_buffer_used;
   heading_done := false;
   for bindex := 1 to buffer_max
   do if (bindex = saved_buffer_number) or  { current buffer or }
         (buffer_pointers[bindex].bptr <> nil)  { used buffer }
      then
      begin
         switch_buffer(bindex);
         save_if_altered
      end;
   int_screen_message('~ buffers saved.', false, saved_count, 1);
   if error_count > 0 then
   begin
      int_screen_message('~ errors reported.', true, error_count, 1);
      main_state := command_error       { cleared in "save_if_altered" }
   end;
   switch_buffer(saved_buffer_number);
   switch_buffer_used := saved_switch_buffer_used
end { saveall_proc } ;

{ Write the current line out to the load_file for UNLOAD and DUNLOAD }

function unload_line: boolean;                                                  { UNLOAD_LINE }

var
   rnw, code: shortint;
   posin: integer;

begin { unload_line }
   if current_buffer.line_exists then
   with current_buffer, current_index^, entries[index_sub], block_ad^,
        load_file do
   begin
      replace_line;                     { ensure file copy up to date }
      if load_use = use_primos then
      begin { write primos file }
         posin := 0;
         prwf$$(k$writ, unit, addressof(data_words[line_start]),
                line_end-line_start+1, posin, rnw, code);
         if code <> 0
         then error_print(k$irtn, code, concat('Writing ',treename.strng),'PRWF$$');
         unload_line := code = 0
      end { write primos file }
      else
      begin { copy to buffer }
         copy_to_buffer(data_words, line_start, line_end);
         unload_line := true
      end { copy to buffer }
   end { with }
   else unload_line := true
end { unload_line } ;

{ Unload the lines from start_line to stop_line inclusive by writing the
  appropriate parts of the file blocks directly }

function quick_unload(start_line, stop_line: integer): boolean;                 { QUICK_UNLOAD }

var
   rnw, code: shortint;
   start_index, stop_index, posin: integer;
   startad, stopad, ad1, ad2: data_words0_range;
   done, ok, user_quit: boolean;

begin { quick_unload }
   with current_buffer do
   begin
      load_a_line(0, false);            { ensure split closed }
      load_a_line(stop_line, false);    { collect stop and start file block }
      stop_index := block_number;       { information }
      stopad := line_end;
      load_a_line(start_line, false);
      start_index := block_number;
      startad := line_start
   end;

   ad1 := startad;                      { start at line start in first block }
   done := false;
   ok := true;
   if main_state = running then
   repeat
      with current_buffer, current_index^, entries[index_sub], block_ad^,
           load_file do
      begin { new with because block changed }
         if block_number = stop_index then
         begin
            ad2 := stopad;              { stop at line end }
            done := true
         end
         else ad2 := split_start - 1;   { or end of block }
         if load_use = use_primos then
         begin { write to primos file }
            posin := 0;
            prwf$$(k$writ, unit, addressof(data_words[ad1]),
                   ad2 - ad1 + 1, posin, rnw, code);
            if code <> 0 then
            begin { failed }
               error_print(k$irtn, code, concat('Writing ',treename.strng),
                           'PRWF$$');
               ok := false
            end { failed }
         end { write to primos file }
         else copy_to_buffer(data_words, ad1, ad2);
         ad1 := 1;                      { start at word 1 for later blocks }
         if not done
         then if get_next_block(user_quit)
              then page_in_block
              else abort('quick_unload: get_next_block failed')
      end { new with because block changed }
   until done or (not ok) or (main_state <> running);
   load_a_line(0, false);               { to set index back ok }
   load_a_line(stop_line, false);       { leave on last line }
   quick_unload := ok
end { quick_unload } ;

{ Delete the lines from start_line to stop_line inclusive by altering and  }
{ deleting file blocks directly.  Leaves the current line as the one after }
{ the last line deleted.                                                   }

procedure quick_delete(start_line, stop_line: integer);                         { QUICK_DELETE }

var
   down: integer;
   start_index, stop_index, iindex: integer;
   startad, stopad, windex: data_words0p1_range;

begin { quick_delete }
   if stop_line < start_line
   then load_a_line(stop_line + 1, false)  { nothing to delete }
   else
   with current_buffer do
   begin
      load_a_line(0, false);            { ensure split closed }
      load_a_line(start_line, false);   { gather start and stop information }
      start_index := block_number;
      startad := line_start;
      load_a_line(stop_line, false);
      if line_status = bottom then      { at .bottom. back up one line }
      begin
         stop_line := line_number - 1;
         load_a_line(stop_line, false)
      end;
      stop_index := block_number;
      stopad := line_end;

      if main_state = running then
      begin
         file_altered := true;
         if marked_line >= start_line then  { keep marked_line up to date }
         begin
            if marked_line <= stop_line
            then marked_line := 0       { it no longer exists }
            else marked_line := marked_line -  { subtract lines gone }
                    (stop_line -start_line + 1)
            {---teststart---}
            ;if mode_test
            then writeln('marked_line = ', marked_line:1)
            {---teststop---}
         end;
         if iw_marked_line >= start_line then  { keep iw_marked_line up to date }
         begin
            if iw_marked_line <= stop_line
            then iw_marked_line := 0    { it no longer exists }
            else iw_marked_line := iw_marked_line -  { subtract lines gone }
                    (stop_line -start_line + 1)
            {---teststart---}
            ;if mode_test
            then writeln('iw_marked_line = ', iw_marked_line:1)
            {---teststop---}
         end;
         if point_line_no >= start_line then  { keep point_line_no up to date }
         begin
            if point_line_no <= stop_line then
            begin { it no longer exists }
               point_line_no := 0;
               point_line_pos := 0
            end { it no longer exists }
            else point_line_no := point_line_no -  { subtract lines gone }
                    (stop_line -start_line + 1)
            {---teststart---}
            ;if mode_test
            then writeln('point_line_no = ', point_line_no:1)
            {---teststop---}
         end;

         { go through blocks from last to first because we can alter blocks }
         { and still get the correct "lines_above" information. }

         { deal with first part of last block }

         with current_index^, entries[index_sub], block_ad^ do
         begin
            if block_number = start_index then
            begin { all in one block }
               down := stopad + 1 - startad;
               block_lines := block_lines - (stop_line - start_line + 1)
            end { all in one block }
            else
            begin { remove first part of last block }
               down := stopad;
               block_lines := block_lines - stop_line + lines_above
            end { remove first part of last block } ;
            paged_out_copy_ok := false;
            { copy remaining words to front of block }
            for windex := (stopad + 1) to (split_start - 1)
            do data_words[windex - down] := data_words[windex];
            split_start := split_start - down
         end;

         { empty the intermediate blocks if any - they will be deleted later }

         for iindex := (stop_index - 1) downto (start_index + 1) do
         begin
            if not get_previous_block
            then abort('quick_delete: get_previous_block failed');
            with current_index^.entries[index_sub] do
            begin
               block_lines := 0;
               paged_out_copy_ok := false
            end
         end;

         { truncate first block at start_line position }

         if block_number <> start_index then
         begin { multi-block }
            if not get_previous_block
            then abort('quick_delete: get_previous_block failed');
            page_in_block;
            with current_index^, entries[index_sub] do
            begin { new with }
               split_start := startad;
               block_lines := start_line - lines_above - 1;
               paged_out_copy_ok := false
            end { new with }
         end { multi-block } ;

         load_a_line(0, false);         { go to top first because we do not }
                                        { have current line information }
         load_a_line(start_line, false)  { was numbered "stop_line" before }
      end
   end
end { quick_delete } ;

{ Strip any spaces from the end of the current line }

procedure strip_trailing_spaces;                                                { STRIP_TRAILING_SPACES }

var
   done: boolean;
   lindex: line_chars_range;

begin { strip_trailing_spaces }
   with current_buffer do
   begin
      if line_status = normal then
      begin { not .top. or .bottom. }
         done := false;
         repeat
            if line_length < 1
            then done := true
            else if line_text[line_length] = ' '
            then line_length := line_length - 1
            else done := true
         until done;
         if (line_number = point_line_no) and
            (line_length < point_line_pos)
         then
         begin { include char pointer within length }
            for lindex := line_length+1 to point_line_pos
            do  line_text[lindex] := ' ';
            line_length := point_line_pos
         end { include char pointer within length } ;
         line_text[line_length+1] := newline
      end { not .top. or .bottom. }
      else { do not tinker with .top. or .bottom. }
   end { with }
end { strip_trailing_spaces } ;

begin { pmed_efs }
end { pmed_efs } .
