program main(input, output);

type
   grouprange = 1..63;

var
   rlbfile: packed file of 0..65535;
   outfile: text;
   blockheader, blocktype, blocksize, blockstart,
   groupheader, grouptype, groupsize, groupstart,
   wordsleft, index: integer;
   filename: string;
   gnumber: grouprange;
   gname: array[grouprange] of string;
   numstr: string;

begin
   for gnumber := 1 to 63 do
   begin
      str(gnumber, numstr);
      gname[gnumber] := concat('Group ',numstr)
   end;
   write('RLB filename: ');
   readln(filename);
   reset(rlbfile, filename);
   write('Output file: ');
   readln(filename);
   rewrite(outfile, filename);
   blockstart := 0;
   while not eof(rlbfile) do
   begin
      read(rlbfile, blockheader);
      blocksize := blockheader mod 256;
      if blocksize > 0
      then read(rlbfile, blockheader);
      blocktype := blockheader div 256;
      writeln(outfile,'block ',blockstart:8,blocktype:8,blocksize:8);
      wordsleft := blocksize - 1;
      groupstart := blockstart + 2;
      while wordsleft > 0 do
      begin
         read(rlbfile, groupheader);
         grouptype := groupheader div 256;
         groupsize := groupheader mod 256;
         writeln(outfile,'      ',groupstart:8,grouptype:8,groupsize:8,
                 '  ',gname[grouptype]);
         if groupsize > wordsleft then
         begin
            writeln(blockstart:1,' ',grouptype,' ',groupsize);
            halt('ER')
         end;
         groupstart := groupstart + groupsize + 1;
         for index := 1 to groupsize
         do get(rlbfile);
         wordsleft := wordsleft - groupsize - 1
      end;
      blockstart := blockstart + blocksize + 1
   end
end.
