{ VDUSETUP for Sheffield University Editor }
{ Copyright (c) University of Sheffield 1990 }

{*************************************}
{ EXTRA GLOBAL VARIABLES FOR VDUSETUP }
{*************************************}

var
   interactive: boolean;
   vdu_table_rec, init_table_rec: vdu_info;
   init_full_entry: full_entry;
   empty_char_pointer: vdu_char_pointer;
   vdu_punctuation: set_of_char;
   init_sequence: sequences;
   expanded: record                     { expanded form of character seqs }
      exp_control_array: array[controls] of sequences;
      exp_reset_string,
      exp_exit_string,
      exp_cursor_string,
      exp_posmacro, exp_negmacro: sequences;
      exp_posmacro_reply, exp_negmacro_reply: sequences;
      exp_posmacro_defined, exp_negmacro_defined: boolean;
      exp_mess_type, exp_arrow_type: integer;
      exp_char_protect, exp_line_protect: boolean;
      exp_input_sequences_head: ptr_char_table;
      exp_poscommand, exp_negcommand: sequences;
      exp_poscommand_repair, exp_negcommand_repair: repair_type;
      exp_poscommand_reply, exp_negcommand_reply: sequences
   end;
   action_proc_info: array[action_proc] of record
      act_name: char12;
      always_soft: boolean
   end;
   ware_names: array[ware_type] of char12;
   repair_names: array[repair_type] of char12;
   vdu_control_names: array[controls] of char12;
   char_names: array[char] of char3;
   string_name: char12;
   extra_information: string;
   answer: alfa;
   source_file, report_file: text;
   binary_file: file of vdu_info;
   source_fn, binary_fn, report_fn: string;
   in_line: packed array[1..200] of char;
   in_length: 0..200;
   line_no: integer;
   entry_length: integer;
   vdu_type_count, in_pos: integer;

value
   vdu_control_names = (
      'backtab     ','scrolloff   ','charinsert  ','chardelete  ',
      'clearatab   ','cleartabs   ','clearscreen ','scrollon    ',
      'ctrlcodeoff ','ctrlcodeon  ','cursorup    ','cursordown  ',
      'cursorleft  ','cursorright ','foldoff     ','foldon      ',
      'horiztab    ','arrowoff    ','arrowon     ','lineerase   ',
      'lineinsert  ','linedelete  ','pageerase   ','reverself   ',
      'settab      ','messoff     ','messon      ');

   action_proc_info = (
   {   name           always software }
      'emptyact    ', true  ,
      'sequence    ', true  ,
      'breakline   ', true  ,
      'carret      ', false ,
      'deleteonech ', false ,
      'deleteonel  ', false ,
      'dofile      ', true  ,
      'doquit      ', true  ,
      'dosave      ', true  ,
      'downmany    ', true  ,
      'dunlfile    ', true  ,
      'duplicate   ', true  ,
      'edcom       ', true  ,
      'emacro      ', true  ,
      'eraseline   ', false ,
      'erroract    ', true  ,
      'exitwi      ', true  ,
      'formtext    ', true  ,
      'godown      ', false ,
      'godownx     ', true  ,
      'gohome      ', false ,
      'goleft      ', false ,
      'goleftx     ', true  ,
      'goright     ', false ,
      'gorightx    ', true  ,
      'goup        ', false ,
      'goupx       ', true  ,
      'helpact     ', true  ,
      'insertmode  ', true  ,
      'insertonech ', false ,
      'insertonel  ', false ,
      'joinline    ', true  ,
      'lfchar      ', false ,
      'lfcharx     ', true  ,
      'lfile       ', true  ,
      'lowcase     ', true  ,
      'markon      ', true  ,
      'markoff     ', true  ,
      'negmacro    ', true  ,
      'nullact     ', true  ,
      'openit      ', true  ,
      'closeit     ', true  ,
      'pointchon   ', true  ,
      'pointchoff  ', true  ,
      'posmacro    ', true  ,
      'redrawl     ', true  ,
      'redraws     ', true  ,
      'repeatit    ', true  ,
      'revlfchar   ', false ,
      'revlfcharx  ', true  ,
      'smacro      ', true  ,
      'dmacro      ', true  ,
      'ispaces     ', true  ,
      'dspaces     ', true  ,
      'storeonech  ', true  ,           { special case - extras always soft }
      'tableft     ', false ,
      'tabright    ', false ,
      'tabstopon   ', true  ,
      'tabstopoff  ', true  ,
      'unlfile     ', true  ,
      'upcase      ', true  ,
      'upmany      ', true  ,
      'wiswitch    ', true  ,
      'xcomm       ', true  ,
      'zap         ', true  ,
      'downscreen  ', true  ,
      'upscreen    ', true  ,
      'litchar     ', true  ,
      'kinthost    ', true  ,
      'ksuspend    ', true  ,
      'krestart    ', true  ,
      'kleftupd    ', true  ,
      'kfirstns    ', true  ,
      'kalastns    ', true  ,
      'keraprev    ', true  ,
      'keraline    ', true  ,
      'keraright   ', true  ,
      'khomefld    ', true  ,
      'knewline    ', true  ,
      'nextwind    ', true  ,
      'prevwind    ', true  );

   ware_names = ('hardware    ', 'software    ');

   repair_names = (
      'ok          ','rest1       ','rest2       ','rest3       ',
      'rest4       ','func        ');

   char_names = (
      '000', '001', '002', '003', '004', '005', '006', '007',
      '010', '011', '012', '013', '014', '015', '016', '017',
      '020', '021', '022', '023', '024', '025', '026', '027',
      '030', '031', '032', '033', '034', '035', '036', '037',
      '040', '041', '042', '043', '044', '045', '046', '047',
      '050', '051', '052', '053', '054', '055', '056', '057',
      '060', '061', '062', '063', '064', '065', '066', '067',
      '070', '071', '072', '073', '074', '075', '076', '077',
      '100', '101', '102', '103', '104', '105', '106', '107',
      '110', '111', '112', '113', '114', '115', '116', '117',
      '120', '121', '122', '123', '124', '125', '126', '127',
      '130', '131', '132', '133', '134', '135', '136', '137',
      '140', '141', '142', '143', '144', '145', '146', '147',
      '150', '151', '152', '153', '154', '155', '156', '157',
      '160', '161', '162', '163', '164', '165', '166', '167',
      '170', '171', '172', '173', '174', '175', '176', '177',
      'NUL', 'SOH', 'STX', 'ETX', 'EOT', 'ENQ', 'ACK', 'BEL',
      'BS ', 'HT ', 'LF ', 'VT ', 'FF ', 'CR ', 'SO ', 'SI ',
      'DLE', 'DC1', 'DC2', 'DC3', 'DC4', 'NAK', 'SYN', 'ETB',
      'CAN', 'EM ', 'SUB', 'ESC', 'FS ', 'GS ', 'RS ', 'US ',
      'SP ', '!  ', '"  ', '#  ', '$  ', '%  ', '&  ', '''  ',
      '(  ', ')  ', '*  ', '+  ', ',  ', '-  ', '.  ', '/  ',
      '0  ', '1  ', '2  ', '3  ', '4  ', '5  ', '6  ', '7  ',
      '8  ', '9  ', ':  ', ';  ', '<  ', '=  ', '>  ', '?  ',
      '@  ', 'A  ', 'B  ', 'C  ', 'D  ', 'E  ', 'F  ', 'G  ',
      'H  ', 'I  ', 'J  ', 'K  ', 'L  ', 'M  ', 'N  ', 'O  ',
      'P  ', 'Q  ', 'R  ', 'S  ', 'T  ', 'U  ', 'V  ', 'W  ',
      'X  ', 'Y  ', 'Z  ', '[  ', '\  ', ']  ', '^  ', '_  ',
      '`  ', 'a  ', 'b  ', 'c  ', 'd  ', 'e  ', 'f  ', 'g  ',
      'h  ', 'i  ', 'j  ', 'k  ', 'l  ', 'm  ', 'n  ', 'o  ',
      'p  ', 'q  ', 'r  ', 's  ', 't  ', 'u  ', 'v  ', 'w  ',
      'x  ', 'y  ', 'z  ', '{  ', '|  ', '}  ', '~  ', 'DEL');
